	-- I had thoughts of having various levels of debug, but I think this file just uses the _showfunctiondebug for most things
	local _showdebug = true;
	local _showfunctiondebug = true;
	local _showbagitemsdebug = false;
	
	-- Function to get things sorted before the bot gets going. Place things in here for easy changing, 
	-- so you dont have to go looking through the whole file looking for some variable to adjust.
	-- Also needed to make a 'backup' of all the bots profile optins so when they are changed during the waypoint files etc, 
	-- they can be easily put back to the way you wanted them to be.
	
	function StartUp()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGe:: Starting StartUp  \n") ; end;

		settings.profile.options.BANK_ITEMS = true -- Do you want the bot to bank items?
		settings.profile.options.SWAP_CLASS = true -- Do you want the bot to swap class?
		settings.profile.options.MAIL_QUEST_ITEMS = 6 -- How many slots should be full of quest items before visiting the Mailbox for sending?
		settings.profile.options.MAIL_RECIPES = 6	-- How many slots should be full of recipes before visiting the Mailbox for sending?
		settings.profile.options.MAIL_PRODUCTION_MATERIALS = 6	-- How many slots should be full of production materials before visiting the Mailbox for sending?
		
		-- This table is to allow easy configuration of the various parameters of the bot, and the things than influence its desision making
		customsettings = {
		defaults = {
			DURABILITY_LOW = 75, 		-- When this % or less is reached, it will trigger a trip to the General Merchant
			BAG_SLOTS_LOW = 5,			-- When this # or less is reached, it will trigger a trip to the General Merchant
			HEALING_POTION_LOW = 10,	-- When this # or less is reached, it will trigger a trip to the General Merchant
			MANA_POTION_LOW = 10,		-- When this # or less is reached, it will trigger a trip to the General Merchant
			QUIVERS_LOW = 1 },			-- When this # or less is reached, it will trigger a trip to the General Merchant
		options = {
			DIFFICULTY_MODIFIER = 0, 	-- The higher the number, the bigger the mobs the character will be fighting (default is 0)
			CLASS_DIFFERENCE = 0, 		-- The number of levels gained before auto swapping class to level up second class (default is 0, meaning there is no second class) 
			MAIL_RECIPIENT1 = "",		-- Items will be mailed to this character. If blank, will be sent to "characternamePA" )you toons name + "pa")(pa=Personal Assistant)
			MAIL_RECIPIENT2 = "",		-- More options to spread things around. You can create more than 4 if you want.
			MAIL_RECIPIENT3 = "",		-- More options to spread things around. You can create more than 4 if you want.
			MAIL_RECIPIENT4 = "" },		-- More options to spread things around. You can create more than 4 if you want.
		profiledefaults = {
			MANA_POTION = settings.profile.options.MANA_POTION,
			HEALING_POTION = settings.profile.options.HEALING_POTION,
			ARROW_QUIVER = settings.profile.options.ARROW_QUIVER,
			BANK_ITEMS = settings.profile.options.BANK_ITEMS,
			SWAP_CLASS = settings.profile.options.SWAP_CLASS,
			MAIL_QUEST_ITEMS = 	settings.profile.options.MAIL_QUEST_ITEMS,
			MAIL_RECIPES = settings.profile.options.MAIL_RECIPES,
			MAIL_PRODUCTION_MATERIALS = settings.profile.options.MAIL_PRODUCTION_MATERIALS,
			COMBAT_DISTANCE = settings.profile.options.COMBAT_DISTANCE,
			MAX_TARGET_DIST = settings.profile.options.MAX_TARGET_DIST,
			LOOT_DISTANCE = settings.profile.options.LOOT_DISTANCE,
			MP_LOW_POTION = settings.profile.options.MP_LOW_POTION},
		quests = {
			ANTEATER_INVESTIGATION = 1,		-- 1 means do it, 0 means don't. bot will set it to 0 once it completes it
			SOUL_CONTAINER = 1 ,			-- 1 means do it, 0 means don't. bot will set it to 0 once it completes it
			ENTS_DEAD_BRANCHES = 1 }		-- 1 means do it, 0 means don't. bot will set it to 0 once it completes it
		};	
		
		if _showfunctiondebug then 
			cprintf(cli.blue," DEBUGs:: Current profile defaults:  \n") ; 
			printf(" customsettings.profiledefaults.ARROW_QUIVER = %s\n", customsettings.profiledefaults.ARROW_QUIVER)
			printf(" customsettings.profiledefaults.MANA_POTION = %s\n", customsettings.profiledefaults.MANA_POTION)
			printf(" customsettings.profiledefaults.HEALING_POTION = %s\n", customsettings.profiledefaults.HEALING_POTION)
			printf(" customsettings.profiledefaults.BANK_ITEMS = %s\n", customsettings.profiledefaults.BANK_ITEMS)
			printf(" customsettings.profiledefaults.SWAP_CLASS = %s\n", customsettings.profiledefaults.SWAP_CLASS)
			printf(" customsettings.profiledefaults.MAIL_QUEST_ITEMS = %s\n", customsettings.profiledefaults.MAIL_QUEST_ITEMS)
			printf(" customsettings.profiledefaults.MAIL_RECIPES = %s\n", customsettings.profiledefaults.MAIL_RECIPES)
			printf(" customsettings.profiledefaults.MAIL_PRODUCTION_MATERIALS = %s\n", customsettings.profiledefaults.MAIL_PRODUCTION_MATERIALS) 
			printf(" customsettings.profiledefaults.MP_LOW_POTION = %s\n", customsettings.profiledefaults.MP_LOW_POTION)
		end;
		if _showfunctiondebug then 
			printf(" \n DEBUGs:: Current profile settings:  \n")
			printf(" settings.profile.options.ARROW_QUIVER = %s \n", settings.profile.options.ARROW_QUIVER)
			printf(" settings.profile.options.MANA_POTION = %s \n", settings.profile.options.MANA_POTION)
			printf(" settings.profile.options.HEALING_POTION = %s \n", settings.profile.options.HEALING_POTION)			
			printf(" settings.profile.options.BANK_ITEMS = %s \n", settings.profile.options.BANK_ITEMS)
			printf(" settings.profile.options.SWAP_CLASS = %s \n", settings.profile.options.SWAP_CLASS)
			printf(" settings.profile.options.MAIL_QUEST_ITEMS = %s \n", settings.profile.options.MAIL_QUEST_ITEMS)
			printf(" settings.profile.options.MAIL_RECIPES = %s \n", settings.profile.options.MAIL_RECIPES)
			printf(" settings.profile.options.MAIL_PRODUCTION_MATERIALS = %s \n", settings.profile.options.MAIL_PRODUCTION_MATERIALS)
			printf(" settings.profile.options.ARROW_QUIVER = %s \n", settings.profile.options.ARROW_QUIVER)
			printf(" settings.profile.options.MP_LOW_POTION = %s \n", settings.profile.options.MP_LOW_POTION)
		end	
		
		SetCustomSettings();
		SetProfileOptions()
	end

	
	-- Function to check various equipment/stats/bag space etc.
	-- Checks mana level, health level, quantity of quivers, available bag space
	-- If a level is too low, character is sent to waypoint "trvltorepair" to head to General merchant for topup/repair
	function CheckEquipment(_nextdestination)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGe:: Starting CheckEquipment  \n") ; end;
		
		player:update();
		SetCustomSettings();
		
		local _pclass = GetStat("priclass");
		local _sclass = GetStat("secclass");
		local _TMpoti, _THpoti, _quivers = GetStat("poti_ammo");
		local _dura = GetStat("dura");
		local _freeslots = GetStat("freeslots");
		
		if ( _nextdestination == "" ) or ( _nextdestination == nil ) then
			_nextdestination = "trvltorepair";
		end;
		
		cprintf(cli.lightblue, "\n Checking Equipment, Quivers, Healing-Mana Potions, Bag Space: \n");
		PrintLine("lightblue");
		
		if ( customsettings.options.DURABILITY_LOW >= _dura ) then			
			cprintf(cli.red, " Weapon durability low: %.1f%%. Heading to Merchant for repairs \n", _dura);
			GoToTag(_nextdestination);
		elseif ( (customsettings.options.BAG_SLOTS_LOW * 2) >= _freeslots ) then
			cprintf(cli.red, " Available Bag Slots low: %s. Heading to Merchant to sell stuff \n", _freeslots);
			GoToTag(_nextdestination);
		elseif ( ( customsettings.options.HEALING_POTION_LOW * 2) >= _THpoti ) then
			cprintf(cli.red, " Health potions low: %s. Heading to Merchant to get more \n", _THpoti);
			GoToTag(_nextdestination);
		elseif ( (customsettings.options.MANA_POTION_LOW * 2) >= _TMpoti ) then
			cprintf(cli.red, " Mana potions low: %s. Heading to Merchant to get more \n", _TMpoti);
			GoToTag(_nextdestination);
		elseif ( (customsettings.options.QUIVERS_LOW * 2) >= _quivers ) and ( _pclass == "Scout" or _pclass == "Rogue" or _sclass == "Scout" or _sclass == "Rogue" ) then
				cprintf(cli.red, " Quivers low: %d. Heading to Merchant to get more \n", _quivers);
				GoToTag(_nextdestination);
		else
			cprintf(cli.green, " Weapon OK: %.0f%% \n", _dura);
			cprintf(cli.green, " Bag slots available OK: %s \n", _freeslots);
			cprintf(cli.green, " Health potions OK: %s \n", _THpoti);
			cprintf(cli.green, " Mana potions OK: %s \n", _TMpoti);
			if ( _pclass == "Scout" ) or ( _pclass == "Rogue" ) or ( _sclass == "Scout" ) or ( _sclass == "Rogue" ) then
				cprintf(cli.green, " Quivers OK: %s \n", _quivers);
			end;
			cprintf(cli.green, " All equipment seems OK, going around again. \n");			
		end;
		PrintLine("lightblue");
		
		return false
	end
	
	-- Function to tweak the bots options depending on its level
	function SetCustomSettings()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGs:: Starting SetCustomSettings  \n") ; end;

		printf(" Setting customsettings.options for Player Level %d.\n", player.Level)
		
		if 11 > player.Level then
			customsettings.options.DURABILITY_LOW = 55
			customsettings.options.BAG_SLOTS_LOW = 0
			customsettings.options.HEALING_POTION_LOW = 2
			customsettings.options.MANA_POTION_LOW = 2			
			customsettings.options.QUIVERS_LOW = 0
		elseif 19 > player.Level then
			customsettings.options.DURABILITY_LOW = 65
			customsettings.options.BAG_SLOTS_LOW = 1
			customsettings.options.HEALING_POTION_LOW = 2
			customsettings.options.MANA_POTION_LOW = 2			
			customsettings.options.QUIVERS_LOW = 1
		elseif 30 > player.Level then
			customsettings.options.DURABILITY_LOW = 75
			customsettings.options.BAG_SLOTS_LOW = 3
			customsettings.options.HEALING_POTION_LOW = 5
			customsettings.options.MANA_POTION_LOW = 5			
			customsettings.options.QUIVERS_LOW = 1
		else
			customsettings.options.DURABILITY_LOW = customsettings.defaults.DURABILITY_LOW
			customsettings.options.BAG_SLOTS_LOW = customsettings.defaults.BAG_SLOTS_LOW
			customsettings.options.HEALING_POTION_LOW = customsettings.defaults.HEALING_POTION_LOW
			customsettings.options.MANA_POTION_LOW = customsettings.defaults.MANA_POTION_LOW			
			customsettings.options.QUIVERS_LOW = customsettings.defaults.QUIVERS_LOW
		end
	end
	
	-- Function to set what the bot should be buying when at the merchant depending on level. 
	-- If your profile says to have 99 potions, and your level 10 bot cant afford 99 potions, 
	-- it will buy none, and then get stuck in a loop trying to go back to buy more til it gets 99.
	function SetProfileOptions(_merchant)
		if _showfunctiondebug then 
			cprintf(cli.blue," DEBUGs:: Starting SetProfileOptions.");
			if _merchant ~= nil then
				printf(" Location:%s\n", _merchant);
			else
				printf("\n");
			end
		end
		
		local _playerclass = GetStat("priclass")
		
		if _showdebug then printf(" DEBUGs:: _playerclass:%s player.Class1:%s level:%d  \n", _playerclass, player.Class1, player.Level) ; end;
		
		if 11 > player.Level then
			if _playerclass == "Mage" or _playerclass == "Priest" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 20
				settings.profile.options.HEALING_POTION = 5
				settings.profile.options.MP_LOW_POTION = 50
			elseif _playerclass == "Scout" then
				settings.profile.options.ARROW_QUIVER = 1
				settings.profile.options.MANA_POTION = 5
				settings.profile.options.HEALING_POTION = 20
				settings.profile.options.MP_LOW_POTION = 50
			elseif _playerclass == "Warrior" then 
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 20
				settings.profile.options.HEALING_POTION = 20
				settings.profile.options.MP_LOW_POTION = 50
			elseif _playerclass == "Knight" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 80
				settings.profile.options.HEALING_POTION = 20
				settings.profile.options.MP_LOW_POTION = 50
			end
		elseif 19 > player.Level then
			if _playerclass == "Mage" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 40
				settings.profile.options.HEALING_POTION = 10
				settings.profile.options.MP_LOW_POTION = 50
			elseif _playerclass == "Scout" then
				settings.profile.options.ARROW_QUIVER = 2
				settings.profile.options.MANA_POTION = 5
				settings.profile.options.HEALING_POTION = 40
				settings.profile.options.MP_LOW_POTION = 50
			elseif _playerclass == "Warrior" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 80
				settings.profile.options.HEALING_POTION = 30
				settings.profile.options.MP_LOW_POTION = 50
			elseif _playerclass == "Knight" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 80
				settings.profile.options.HEALING_POTION = 20
				settings.profile.options.MP_LOW_POTION = 50
			end
		elseif 26 > player.Level then
			if _playerclass == "Mage" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 150
				settings.profile.options.HEALING_POTION = 50
				settings.profile.options.MP_LOW_POTION = 70
			elseif _playerclass == "Scout" then
				settings.profile.options.ARROW_QUIVER = 4
				settings.profile.options.MANA_POTION = 10
				settings.profile.options.HEALING_POTION = 99
				settings.profile.options.MP_LOW_POTION = 70
			elseif _playerclass == "Warrior" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 78
				settings.profile.options.HEALING_POTION = 75
				settings.profile.options.MP_LOW_POTION = 70
			elseif _playerclass == "Knight" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 75
				settings.profile.options.HEALING_POTION = 75
				settings.profile.options.MP_LOW_POTION = 70
			end
		elseif 30 > player.Level then
			if _playerclass == "Mage" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 99
				settings.profile.options.HEALING_POTION = 50
				settings.profile.options.MP_LOW_POTION = customsettings.profiledefaults.MP_LOW_POTION
			elseif _playerclass == "Scout" then
				settings.profile.options.ARROW_QUIVER = 4
				settings.profile.options.MANA_POTION = 10
				settings.profile.options.HEALING_POTION = 99
				settings.profile.options.MP_LOW_POTION = customsettings.profiledefaults.MP_LOW_POTION
			elseif _playerclass == "Warrior" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 78
				settings.profile.options.HEALING_POTION = 75
				settings.profile.options.MP_LOW_POTION = customsettings.profiledefaults.MP_LOW_POTION
			elseif _playerclass == "Knight" then
				settings.profile.options.ARROW_QUIVER = 0
				settings.profile.options.MANA_POTION = 75
				settings.profile.options.HEALING_POTION = 75
				settings.profile.options.MP_LOW_POTION = customsettings.profiledefaults.MP_LOW_POTION
			end
		else 
			settings.profile.options.MP_LOW_POTION = customsettings.profiledefaults.MP_LOW_POTION
		end
		-- The Mercahnt is the central point, and not all towns have everything, so need to adjust things to 
		-- stop bot trying to bank items at a location that does not have a bank
		if _merchant == "Ottade" then
			if _showfunctiondebug then printf(" DEBUGs :: Merchant: Ottade, setting profile options accordingly  \n") ; end;
			settings.profile.options.BANK_ITEMS = false
			settings.profile.options.SWAP_CLASS = false
			settings.profile.options.MAIL_QUEST_ITEMS = 18
			settings.profile.options.MAIL_RECIPES = 18
			settings.profile.options.MAIL_PRODUCTION_MATERIALS = 18
			
			if settings.profile.options.ARROW_QUIVER > 0 then
				settings.profile.options.ARROW_QUIVER = 1
			end
		elseif _merchant == "Loca Roco" then
			settings.profile.options.BANK_ITEMS = false
			settings.profile.options.SWAP_CLASS = false
			settings.profile.options.MAIL_QUEST_ITEMS = 18
			settings.profile.options.MAIL_RECIPES = 18
			settings.profile.options.MAIL_PRODUCTION_MATERIALS = 18
			if settings.profile.options.ARROW_QUIVER > 0 then
				settings.profile.options.ARROW_QUIVER = 1
			end
		elseif _merchant == "Raylinbas" and player.Level < 41 then
			settings.profile.options.BANK_ITEMS = customsettings.profiledefaults.BANK_ITEMS	
			settings.profile.options.SWAP_CLASS = customsettings.profiledefaults.SWAP_CLASS
			settings.profile.options.MAIL_QUEST_ITEMS = customsettings.profiledefaults.MAIL_QUEST_ITEMS
			settings.profile.options.MAIL_RECIPES = customsettings.profiledefaults.MAIL_RECIPES
			settings.profile.options.MAIL_PRODUCTION_MATERIALS = customsettings.profiledefaults.MAIL_PRODUCTION_MATERIALS	
			settings.profile.options.ARROW_QUIVER = customsettings.profiledefaults.ARROW_QUIVER	
			settings.profile.options.HEALING_POTION = 0
		else
			settings.profile.options.BANK_ITEMS = customsettings.profiledefaults.BANK_ITEMS	
			settings.profile.options.SWAP_CLASS = customsettings.profiledefaults.SWAP_CLASS
			settings.profile.options.MAIL_QUEST_ITEMS = customsettings.profiledefaults.MAIL_QUEST_ITEMS
			settings.profile.options.MAIL_RECIPES = customsettings.profiledefaults.MAIL_RECIPES
			settings.profile.options.MAIL_PRODUCTION_MATERIALS = customsettings.profiledefaults.MAIL_PRODUCTION_MATERIALS	
			settings.profile.options.ARROW_QUIVER = customsettings.profiledefaults.ARROW_QUIVER	
			
		end
		if _showfunctiondebug then 
			printf(" DEBUGs:: Have changed some profile settings:  \n")
			printf(" settings.profile.options.ARROW_QUIVER = %s \n", settings.profile.options.ARROW_QUIVER)
			printf(" settings.profile.options.MANA_POTION = %s \n", settings.profile.options.MANA_POTION)
			printf(" settings.profile.options.HEALING_POTION = %s \n", settings.profile.options.HEALING_POTION)			
			printf(" settings.profile.options.BANK_ITEMS = %s \n", settings.profile.options.BANK_ITEMS)
			printf(" settings.profile.options.SWAP_CLASS = %s \n", settings.profile.options.SWAP_CLASS)
			printf(" settings.profile.options.MAIL_QUEST_ITEMS = %s \n", settings.profile.options.MAIL_QUEST_ITEMS)
			printf(" settings.profile.options.MAIL_RECIPES = %s \n", settings.profile.options.MAIL_RECIPES)
			printf(" settings.profile.options.MAIL_PRODUCTION_MATERIALS = %s \n", settings.profile.options.MAIL_PRODUCTION_MATERIALS)
			printf(" settings.profile.options.ARROW_QUIVER = %s \n", settings.profile.options.ARROW_QUIVER)
			printf(" settings.profile.options.MP_LOW_POTION = %s \n", settings.profile.options.MP_LOW_POTION)
		end		
	end	
	
	-- Function to talk to merchant, and display stats before and after. 
	-- Designed for general merchant buy/sell and repair 
	function AtMerchant(_merchantname)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGa:: Starting AtMerchant  \n") ; end;
		
		player:update();
		
		-- if setprofileoptions ~= 1 then
			-- SetProfileOptions("mana", "healing");
		-- end
		
		if free_counter1 == nil then 
			free_counter1 = 0; 
		end
		local _durabefore = GetStat("dura");
		local _quivers = GetStat("quivers");
		local _class = GetStat("priclass");
		cprintf(cli.lightblue, "\n At General Merchant: ");
		cprintf(cli.yellow,"%s. Merchant visits: %d\n", _merchantname, free_counter1);
		PrintLine();
		player:merchant(_merchantname);					
		player:rest(4);
		-- SellItems(_merchantname);
		printf(" Finished with _merchant %s \n", _merchantname);
		local _dura = GetStat("dura");
		local _freeslots = GetStat("freeslots");
		printf(" durability Before: %.1f%% \n", _durabefore);
		printf(" durability Now: %s \n", _dura);
		printf(" Space freed up: %d \n", _freeslots);		
		PrintLine("lightblue");
		_emptybagslots = 0;
		local _manapotion = (GetStat("mana"))
		local _healingpotion = (GetStat("health"))
		local _tmpmanapotion = settings.profile.options.MANA_POTION
		local _tmphealingpotion = settings.profile.options.HEALING_POTION
		
		if settings.profile.options.MANA_POTION > _manapotion then
			changeProfileOption("MANA_POTION", (_tmpmanapotion - 10));
		end		
		
		if settings.profile.options.HEALING_POTION > _healingpotion then
			changeProfileOption("HEALING_POTION", (_tmphealingpotion - 10));
		end
		free_counter1 = free_counter1 + 1;
		
		return false
	end
	
	
	-- Function to sell items, mainly to get around the situation of swapping class 
	-- and then having bags full of potions and ammo that are too high a level to use.
	-- think this is going to become obsolete with the update to store.lua I think
	function SellItems(_merchantname)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGs:: Starting SellItems  \n") ; end;
		
		-- sell potions and ammo that is too high a level for the character
		if player:openStore(_merchantname) then 
			yrest(500)
			DisplayItemTypes()
			for i = 61,120 do -- first 2 bags
				local item = inventory.BagSlot[i]
				
				if _showdebug then 
					local _bagslotnum = ( i - 60 )
					local _itemtype = (item:getTypes())
					local _objtype = itemtypes[item.ObjType].Name
					local _itemlvl = item.RequiredLvl
					local _playerlvl = player.Level
					local _itemworth = item.Worth
					printf(" DEBUGs::i=%d slot=%d itemistype=%s itemlvl=%d playerlvl=%d itemworth=%d\n",i, _bagslotnum,_objtype,_itemlvl,_playerlvl,_itemworth) ; 
				end;
				
				if ((item:isType("Potions")) or (string.find(string.lower(item.Name),string.lower("Quiver")))) and ( item.RequiredLvl > player.Level ) and ( item.Worth >= 1 ) then -- some items can't be sold
					printf(" Selling %s \n", item.Name);
					item:use()
					yrest(1000)
				end
			end
		end	
	end
	
	
	-- Function to Change Channels 
	function ChangeChannel()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting ChangeChannel   \n") ; end;
		
		id = RoMScript("GetCurrentParallelID()");
		cprintf(cli.lightblue, "\n Change Channels: \n");
		PrintLine("lightblue");
		
		if ( id == 1 ) then
			RoMScript("ChangeParallelID(2)");
			printf(" Current channel: 1 \n");
			printf(" Changing to Channel: 2 \n");
		elseif ( id == 2 ) then
			RoMScript("ChangeParallelID(3)");
			printf(" Current channel: 2 \n");
			printf(" Changing to Channel 3 \n");
		elseif ( id == 3 ) then
			RoMScript("ChangeParallelID(1)");
			printf(" Current channel: 3 \n");
			printf(" Changing to Channel 1 \n");
		end;
		yrest(30000);
		keyboardPress(key.VK_SPACE); -- Get up from sitting
		PrintLine("lightblue");
		
		if _dotodolist == 1 then
			printf(" Crossing Check Level off the todo list. Setting _checklevel to 0 \n");
		end
		_changechannel = 0;
	end
	
	
	-- Function to Check primary level, and load the appropriate waypoint file.
	-- Use this Function to determine at what level the character will move on to different areas/mobs.
	function CheckLevel(_camefrom)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting CheckLevel  \n") ; end;
		if _showdebug then printf(" DEBUGc:: _camefrom = %s \n", _camefrom) ; end;
		
		printf(" Crossing Check Level off the todo list. Setting _checklevel to 0 \n");
		_checklevel = 0;
		_dotodolist = 0;
		local _plevel = GetStat("prilvl");
		local _plevel2 = GetStat("seclvl");
		player:update()
		cprintf(cli.lightblue,"\n Checking player level: \n");
		PrintLine();
		printf(" Player level: %d \n", _plevel);
		-- printf(" Player progress to next level: %.2f%% \n", pexperience);
		printf(" Came from waypoint path: %s \n", _camefrom);		
		-------------------------------------------------------------------------------		
		if ( _plevel > (99 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around xxx level xxx - xxx
			if ( _camefrom == "aroundxxx" ) then -- Continue on doing around??? area
				ContinueAroundArea(_camefrom);
			elseif ( _camefrom == "xxxtrvlxxx" ) then -- Start doing around??? area
				LoadWaypoints("aroundxxx");
			elseif ( _traveling == "yes" ) then
				printf(" Continue _traveling along "); cprintf(cli.yellow, "travel"); printf(" waypoints. \n");
			else	-- Changing _merchants, so need to travel to Some _merchant before starting aroundsome area.
				printf(" Heading to some _merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------	
		-------------------------------------------------------------------------------	
		elseif ( _plevel > (48 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Ants2 level 47 - 49
			if ( _camefrom == "Raylinbas" ) then -- head to aroundants2
				loadPaths("aroundants2");
			elseif ( _camefrom == "Jacques") then -- head Obsidian Stronghold
				loadPaths("travel");
			else	-- Changing Merchants, so need to travel to Obsidian Stronghold before starting aroundants2 area.
				printf(" Heading to "); cprintf(cli.yellow, "Obsidian Stronghold"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------	
		elseif ( _plevel > (46 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Ants level 45 - 47
			if ( _camefrom == "Raylinbas" ) then -- head to aroundants
				loadPaths("aroundants");
			elseif ( _camefrom == "Jacques") then -- head Obsidian Stronghold
				loadPaths("travel");
			else	-- Changing Merchants, so need to travel to Obsidian Stronghold before starting aroundants4 area.
				printf(" Heading to "); cprintf(cli.yellow, "Obsidian Stronghold"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (42 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Scorpions4 level 43 - 45
			if ( _camefrom == "Raylinbas" ) then -- head to aroundscorpions4
				loadPaths("aroundscorpions4");
			elseif ( _camefrom == "Jacques") then -- head Obsidian Stronghold
				loadPaths("travel");
			else	-- Changing Merchants, so need to travel to Obsidian Stronghold before starting aroundscorpions4 area.
				printf(" Heading to "); cprintf(cli.yellow, "Obsidian Stronghold"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (40 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Scorpions2 level 41 - 43
			if ( _camefrom == "Raylinbas" ) then -- head to aroundscorpions2
				loadPaths("aroundscorpions2");
			elseif ( _camefrom == "Jacques") then -- head Obsidian Stronghold
				loadPaths("travel");
			else	-- Changing Merchants, so need to travel to Obsidian Stronghold before starting aroundscorpions2 area.
				printf(" Heading to "); cprintf(cli.yellow, "Obsidian Stronghold"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (38 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Scorpions level 39 - 41
			if ( _camefrom == "Raylinbas" ) then -- head to aroundscorpions
				loadPaths("aroundscorpions");
			elseif ( _camefrom == "Jacques") then -- head Obsidian Stronghold
				loadPaths("travel");
			else	-- Changing Merchants, so need to travel to Obsidian Stronghold before starting aroundscorpions area.
				printf(" Heading to "); cprintf(cli.yellow, "Obsidian Stronghold"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------			
		elseif ( _plevel > (37 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Wolves level 37 - 39
			if ( _camefrom == "Jacques" ) then -- head to aroundwolves
				loadPaths("aroundwolves");
			elseif ( _camefrom == "Loca Roco" ) then -- head back to Harf Trading Post (Jacques)
				loadPaths("travel");
			elseif ( _camefrom == "Raylinbas") then -- head back to Harf Trading Post
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Harf Trading Post before starting aroundwolves area.
				printf(" Heading to "); cprintf(cli.yellow, "Harf Trading Post"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------	
		elseif ( _plevel > (36 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Minotaurs level 37 - 39
			if ( _camefrom == "Jacques" ) then -- head to Frostwood
				loadPaths("travelfrostwood");
			elseif ( _camefrom == "Loca Roco" ) then -- head to aroundminotaurs
				loadPaths("aroundminotaurs");
			elseif ( _camefrom == "Raylinbas") then -- head back to Harf Trading Post
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Harf Trading Post before starting aroundminotaurs area.
				printf(" Heading to "); cprintf(cli.yellow, "Harf Trading Post"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (34 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Cyclops level 35 - 37
			if ( _camefrom == "Jacques" ) then -- head to Frostwood
				loadPaths("travelfrostwood");
			elseif ( _camefrom == "Loca Roco" ) then -- head to aroundcyclops
				loadPaths("aroundcyclops");
			elseif ( _camefrom == "Raylinbas") then -- head back to Harf Trading Post
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Harf Trading Post before starting aroundmoose area.
				printf(" Heading to "); cprintf(cli.yellow, "Harf Trading Post"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;		
		-------------------------------------------------------------------------------
		elseif ( _plevel > (32 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Moose level 33 - 35
			if ( _camefrom == "Jacques" ) then -- head to aroundmoose
				loadPaths("aroundmoose");
			elseif ( _camefrom == "tree" or _camefrom == "Raylinbas") then -- head back to Harf Trading Post
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Harf Trading Post before starting aroundmoose area.
				printf(" Heading to "); cprintf(cli.yellow, "Harf Trading Post"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (30 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Reindeer level 31 - 33
			if ( _camefrom == "Jacques" ) then -- head to aroundreindeer
				loadPaths("aroundreindeer");
			elseif ( _camefrom == "tree" or _camefrom == "Raylinbas") then -- head back to Harf Trading Post
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Harf Trading Post before starting aroundreindeer area.
				printf(" Heading to "); cprintf(cli.yellow, "Harf Trading Post"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (28 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Flowers level 25 - 27
			if ( _camefrom == "Miles" ) then -- head to aroundflowers
				loadPaths("aroundflowers");
			elseif ( _camefrom == "Jacques" ) then -- head back to Silverfall
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Silverfall before starting aroundflowers area.
				printf(" Heading to "); cprintf(cli.yellow, "Silverfall"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;		
		-------------------------------------------------------------------------------
		elseif ( _plevel > (26 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Ents level 26 - 25
			if ( _camefrom == "Miles" ) then -- head to aroundents
				loadPaths("aroundents");
			elseif ( _camefrom == "Jacques" ) then -- head back to Silverfall
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Silverfall before starting aroundents area.
				printf(" Heading to "); cprintf(cli.yellow, "Silverfall"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------		
		elseif ( _plevel > (24 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Boars level 24 - 26 	
			if ( _camefrom == "Miles" ) then -- head to aroundboars
				loadPaths("aroundboars");
			elseif ( _camefrom == "Jacques" ) then -- head back to Silverfall
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Silverfall before starting aroundboars area.
				printf(" Heading to "); cprintf(cli.yellow, "Silverfall"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;		
		-------------------------------------------------------------------------------
		elseif ( _plevel > (23 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Anteaters2 level 21 - 22
			if ( _camefrom == "Ottade" ) then -- head to aroundanteaters2
				loadPaths("aroundanteaters2");
			elseif ( _camefrom == "Miles" ) then -- head back to Qilana Camp
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Qilana Camp before starting aroundanteaters area.
				printf(" Heading to "); cprintf(cli.yellow, "Qilana Camp"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (18 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Anteaters level 19 - 21
			if ( _camefrom == "Ottade" ) then -- head to aroundanteaters
				loadPaths("aroundanteaters");
			elseif ( _camefrom == "Miles" ) then -- head back to Qilana Camp
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Qilana Camp before starting aroundtagena area.
				printf(" Heading to "); cprintf(cli.yellow, "Qilana Camp"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end;
		-------------------------------------------------------------------------------
		elseif ( _plevel > (17 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Tagena level 17 - 19
			if ( _camefrom == "Ottade" ) then
				loadPaths("aroundtagena");
			elseif ( _camefrom == "silverfallmerchant" ) then 
				loadPaths("travelback");
			else	-- Changing Merchants, so need to travel to Qilana Camp before starting aroundtagena area.
				printf(" Heading to "); cprintf(cli.yellow, "Qilana Camp"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end
		-------------------------------------------------------------------------------
		elseif ( _plevel > (16 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Bats level 15 - 17
			if ( _camefrom == "Jose" ) then
				loadPaths("aroundbats");
			else	-- Changing Merchants, so need to travel to Varanas before starting around? area.
				printf(" Heading to "); cprintf(cli.yellow, "Varanas"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end
		-------------------------------------------------------------------------------
		elseif ( _plevel > (10 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around Yuri level 12 - 15
			if ( _camefrom == "Jose" ) then
				loadPaths("aroundyuri");
			else	-- Changing Merchants, so need to travel to Varanas before starting aroundyuri area.
				printf(" Heading to "); cprintf(cli.yellow, "Varanas"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end
		-------------------------------------------------------------------------------
		elseif ( _plevel > (11 - customsettings.options.DIFFICULTY_MODIFIER)) then -- around ? level 10 - 12
			if ( _camefrom == "Jose" ) then
				loadPaths("around?");
			else	-- Changing Merchants, so need to travel to Varanas before starting aroundyuri area.
				printf(" Heading to "); cprintf(cli.yellow, "Varanas"); printf(" Merchant for start of next area. \n");
				loadPaths("travel");
			end
		-------------------------------------------------------------------------------
		else
			cprintf(cli.red, " OK, so you are a newbie, you shouldn't be here, go somewhere else.\n");
	  	end; 	
		-------------------------------------------------------------------------------
		PrintLine();
		
		return false
	end
	
	
	-- Function to check if its time to swap classes, to keep the level difference no greater than 2.
	function CheckClassSwap(_camefrom)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting  CheckClassSwap \n") ; end;
		if _showdebug then	printf(" DUBUGc::  Starting CheckClassSwap, _camefrom= %s   \n",  _camefrom);	end;
		
		if ((player.Level - player.Level2) >= customsettings.options.CLASS_DIFFERENCE ) then
			printf(" Heading to: "); cprintf(cli.yellow, "Home"); printf(" to swap class. \n");			
			if ( _camefrom == "Raylinbas" )	then
				loadPaths("travelhome");
				return true
			else	-- Use Recall to get to town
				UseASkill("recall");
				loadPaths("travel");
				return true
			end
			if _showdebug then	printf(" DUBUGc::  CheckClassSwap Function returning true \n");	end;
		end
		if _showdebug then	printf(" DUBUGc::  CheckClassSwap Function returning false \n");	end;
		
		return false		
	end
	
	
	-- Function to display a list of various stats
	-- also checks potion, bag slot, dura levels, and if to low, sets waypoint type to RUN.
	-- This makes bot move to the equipmentcheck waypoint faster and get to _merchant faster.
	function DisplayStats()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGd:: Starting DisplayStats  \n") ; end;
		
		player:update();
		_gotorepair = false
		local _charname = player.Name
		local _healthp = (player.HP/player.MaxHP*100);
		local _manap = (player.MP/player.MaxMP*100);
		local _dura = GetStat("dura");
		local _questsleft = GetStat("questcount");
		local _bagslots = GetStat("freeslots");
		local _TMpoti, _THpoti, _quivers = GetStat("poti_ammo");
		local _pclass = GetStat("priclass");
		local _sclass = GetStat("secclass");
		local _plevel = GetStat("prilvl");
		local _slevel = GetStat("seclvl");
		local _manalvl = (settings.profile.options.MANA_POTION/100);
		local _healthlvl = (settings.profile.options.HEALING_POTION/100);
        
		cprintf(cli.lightblue, "\n Current Stats: ");
		printf("%s \n", _charname);
        PrintLine("lightblue");
	-- display Mana --	
        printf(" Mana ");
			if ( 20 > _manap ) then
				cprintf(cli.red, "BAD!: %.1f%% \n", _manap);
			elseif ( 35 > _manap ) then
				cprintf(cli.yellow, "Low: %.1f%% \n", _manap);
			elseif ( 55 > _manap ) then
				cprintf(cli.lightblue, "OK: %.1f%% \n", _manap);
			elseif ( 80 > _manap ) then
				printf("OK: %.1f%% \n", _manap);
			elseif ( 95 > _manap ) then
				cprintf(cli.green, "Good: %.1f%% \n", _manap);
			else
				cprintf(cli.green, "Great: %.0f%% \n", _manap);
			end;		
	-- display Health --	
        printf(" Health ");
			if ( 25 > _healthp ) then
				cprintf(cli.red, "BAD!: %.1f%% \n", _healthp);
			elseif ( 40 > _healthp ) then
				cprintf(cli.yellow, "BAD!: %.1f%% \n", _healthp);
			elseif ( 60 > _healthp ) then
				cprintf(cli.lightblue, "Low: %.1f%% \n", _healthp);
			elseif ( 85 > _healthp ) then
				printf("OK: %.1f%% \n", _healthp);
			elseif ( 95 > _healthp ) then
				cprintf(cli.green, "Good: %.1f%% \n", _healthp);
			else
				cprintf(cli.green, "Great: %.0f%% \n", _healthp);
			end;
	-- check quivers if primary or secondary class is Scout or Rogue -->
		if ( _pclass == "Scout" ) or ( _pclass == "Rogue" ) or ( _sclass == "Scout" ) or ( _sclass == "Rogue" ) then
			printf(" Quivers ");
			if ( 1 > _quivers ) then
				cprintf(cli.red, "LOW!: %s \n", _quivers);
				if _plevel > 10 then
					cprintf(cli.red, ", setting waypoint type to Run. \n"); 
					Run();
					_gotorepair = true
				else
					printf(". \n");
				end
			elseif ( 2 > _quivers ) then
				cprintf(cli.yellow, "Low: %s \n", _quivers);
			elseif ( 3 > _quivers ) then
				cprintf(cli.lightblue, "OK: %s \n", _quivers);
			elseif ( 4 > _quivers ) then
				printf("OK: %s \n", _THpoti);
			elseif ( 5 > _quivers ) then
				cprintf(cli.green, "Good: %s \n", _quivers);
			else
				cprintf(cli.green, "Great: %s \n", _quivers);
			end;
		end;
	-- check available bag slots --	
	    printf(" Bag Space ");
		if ( 2 > _bagslots ) then
			cprintf(cli.red, "ZERO!, setting waypoint type to Run. \n");
			Run();
			_gotorepair = true
		elseif ( 6 > _bagslots ) then
			cprintf(cli.red, "BAD!: %s \n", _bagslots);
		elseif ( 11 > _bagslots ) then
			cprintf(cli.yellow, "Low: %s \n", _bagslots);
		elseif ( 16 > _bagslots ) then
			cprintf(cli.lightblue, "OK: %s \n", _bagslots);
		elseif ( 21 > _bagslots ) then
			printf("OK: %s \n", _bagslots);
		elseif ( 31 > _bagslots ) then
			cprintf(cli.green, "Good: %s \n", _bagslots);
		else
			cprintf(cli.green, "Great: %s \n", _bagslots);
		end;
	-- check Mana Potions --
		printf(" Mana Potions ");
			if (  customsettings.options.MANA_POTION_LOW > _TMpoti ) then
				cprintf(cli.red, "BAD!: %s", _TMpoti);
				if _plevel > 10 then
					cprintf(cli.red, ", setting waypoint type to Run. \n"); 
					Run();
					_gotorepair = true
				else 
					printf(". \n");
				end
			elseif ( _manalvl*15 > _TMpoti ) then
				cprintf(cli.yellow, "Low: %s \n", _TMpoti);
			elseif ( _manalvl*25 > _TMpoti ) then
				cprintf(cli.lightblue, "OK: %s \n", _TMpoti);
			elseif ( _manalvl*50 > _TMpoti ) then
				printf("OK: %s \n", _TMpoti);
			elseif ( _manalvl*75 > _TMpoti ) then
				cprintf(cli.green, "Good: %s \n", _TMpoti);
			else
				cprintf(cli.green, "Great: %s \n", _TMpoti);
			end;		
	-- check Health Potions -->
		printf(" Health Potions ");
			if ( customsettings.options.HEALING_POTION_LOW > _THpoti ) then
				cprintf(cli.red, "BAD!: %s", _THpoti);
				if _plevel > 10 then
					cprintf(cli.red, ", setting waypoint type to Run. \n"); 
					Run();
					_gotorepair = true
				else 
					printf(". \n");
				end
			elseif ( 35 > _THpoti ) then
				cprintf(cli.yellow, "Low: %s \n", _THpoti);
			elseif ( 55 > _THpoti ) then
				cprintf(cli.lightblue, "OK: %s \n", _THpoti);
			elseif ( 100 > _THpoti ) then
				printf("OK: %s \n", _THpoti);
			elseif ( 155 > _THpoti ) then
				cprintf(cli.green, "Good: %s \n", _THpoti);
			else
				cprintf(cli.green, "Great: %s \n", _THpoti);
			end;	
	-- check Daily Quest Count -->
		printf(" Dailies left:  ");
		cprintf(cli.green, "%d \n", _questsleft);
	-- check Weapon durability --  
		printf(" Weapon Durability ");
			if ( 65 > _dura ) then
				cprintf(cli.red, "BAD!: %.1f%%, setting waypoint type to Run. \n", _dura);
				_gotorepair = true
				Run();
			elseif ( 70 > _dura ) then
				cprintf(cli.yellow, "Low: %.1f%% \n", _dura);
			elseif ( 75 > _dura ) then
				cprintf(cli.lightblue, "OK: %.1f%% \n", _dura);
			elseif ( 85 > _dura ) then
				printf("OK: %.1f%% \n", _dura);
			elseif ( 95 > _dura ) then
				cprintf(cli.green, "Good: %.1f%% \n", _dura);
			else				
				cprintf(cli.green, "Great: %.1f%% \n", _dura);
			end;
	-- display Class & Level
		printf(" Class/Level: "); cprintf(cli.green, "%s", _pclass); printf("(%d)  ", _plevel);
		cprintf(cli.green, "%s", _sclass); printf("(%d) \n", _slevel);			
		PrintLine("lightblue");
		
		return false
	end
	
	
	-- Function to set the waypoint type to TRAVEL
	function Travel()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting Travel  \n") ; end;
		__WPL:setForcedWaypointType("TRAVEL");
		printf("\n Setting Waypoint Type to: ");
		cprintf(cli.yellow,"TRAVEL\n");
		changeProfileOption("QUICK_TURN", true); 
		
		return false
	end
	-- Function to set the waypoint type to RUN
	function Run()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGr:: Starting Run  \n") ; end;
		__WPL:setForcedWaypointType("RUN");
		printf("\n Setting Waypoint Type to:"); 
		cprintf(cli.yellow,"RUN\n");
		changeProfileOption("QUICK_TURN", true);
		
		return false
	end
	-- Function to set the waypoint type to NORMAL
	function Normal()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting Normal  \n") ; end;
		__WPL:setForcedWaypointType("NORMAL");
		printf("\n Setting Waypoint Type to: ");
		cprintf(cli.yellow,"NORMAL\n");
		-- changeProfileOption("QUICK_TURN", false);
		
		return false
	end
	
	
	-- Function to print a white line, or coloured if Function is passed a color. (all about asthetics of course)
	function PrintLine(_color)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting PrintLine  \n") ; end;
		if ( _color == "red" ) then
			cprintf(cli.red, " ---------------------------\n");
		elseif ( _color == "yellow" ) then
			cprintf(cli.yellow, " ---------------------------\n");
		elseif ( _color == "lightblue" ) then
			cprintf(cli.lightblue, " ---------------------------\n");
		elseif ( _color == "blue" ) then
			cprintf(cli.blue, " ---------------------------\n");
		elseif ( _color == "green" ) then
			cprintf(cli.green, " ---------------------------\n");
		else
			printf(" ---------------------------\n");
		end;
		
		return false
	end
	
	
	-- Function to move to a pre defined tag inside the currently loaded waypoint file.
	function GoToTag(_tagname)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGg:: Starting GoToTag, _tagname=%s  \n", _tagname) ; end;
		
		if _tagname == nil or _tagname == "" then
			_tagname = "trvltorepair"
			printf(" Trying to go to a waypoint tag, but it is nil, so assuming tag=trvltorepair \n");
		end
		__WPL:setWaypointIndex(__WPL:findWaypointTag(_tagname));
		printf("\n Going to Waypoint: ");
		cprintf(cli.yellow,"%s \n", _tagname);
		
		return false
	end
	
	
	-- Function to Load the new .xml file passed to the Function.
	function LoadWaypoints(_newpath)	
		if _showfunctiondebug then cprintf(cli.blue," DEBUGl:: Starting LoadWaypoints  \n") ; end;
		
		if _showdebug then printf(" DEBUGl:: inside loadwaypoints, _newpath= %s\n", _newpath); end;
		printf(" Loading: "); cprintf(cli.yellow, _newpath); printf(" waypoints. \n");
		loadPaths(_newpath);
		
		return false
	end
	
	
	-- If there seems to be no place to head when doing a CheckLevel, then you will end up here.
	-- Not a good place to end up.
	function LostMyWay(_errorcode)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGl:: Starting LostMyWay   \n") ; end;
		
		printf(" I might be lost, but waiting here awhile before loading: "); 
		cprintf(cli.yellow, "travel"); printf(" waypoints. %s \n", _errorcode);
		yrest(480000);
		LoadWaypoints("travel");
		
		return false
	end
	
	
	-- Function to retrive different types of stats. 
	-- Accepts "poti_ammo","todo","mana","health","quivers","dura","freeslots","prilvl","seclvl","priclass","secclass","recipes","classdifference","dailyquest","questitems"
	-- note: this was one of my first functions, and I just kept adding to it as I learnt lua, it is extremely inefficient, clunky and cumbersome. Needs complete overhaul. 
	function GetStat(_whatstat)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGg:: Starting GetStat  \n") ; end;
		
		player:update();
		inventory:update();
		local _class = "0";	
		local _startslot = 60;
		local _finishslot = 120;
		local _TMpoti = 0;
		local _THpoti = 0;
		local _quivers = 0;
		local _recipes = 0;
		local _productionmaterials = 0;
		local _questitems = 0;
		local _dailyquestcount, _dailyquestsperday = RoMScript("Daily_count()")
		if _dailyquestsperday == nil then 
			_dailyquestsperday = 10 
		end; 
		local _dailyquestsleft = ( _dailyquestsperday - _dailyquestcount );
		local _plevel = player.Level;
		local _slevel = player.Level2 or 0; -- 0 if no second class present
		
		if _slevel ~= 0 and settings.profile.options.SWAP_CLASS then
			local _classdifference = ( _plevel - _slevel );
		else
			_classdifference = _slevel
		end
		
		if ( _whatstat == "poti_ammo" ) or ( _whatstat == "todo" ) or ( _whatstat == "mana" ) 
			or ( _whatstat == "health" ) or ( _whatstat == "quivers" ) or ( _whatstat == "recipes" ) or ( _whatstat == "questitems" ) then
			for item = _startslot, _finishslot, 1 do -- for each bag slot
				local _bagitem = inventory.BagSlot[item];
				local _bagitemid = _bagitem.Id;
				local consumable = database.consumables[_bagitemid];
				local _bagitemtype = _bagitem.ObjType;
				local _bagslotnum = ((item) - 60);
				local _total = 1;
				
				if ( consumable ) and (( consumable.Type == "mana" ) or ( consumable.Type == "mot" )) and ( consumable.Level <= player.Level ) then
					_TMpoti = _TMpoti + _bagitem.ItemCount;
					_total = _TMpoti;
					-- if _showdebug then printf(" DEBUGa:: slot:%d :%d %s's. Total:%d\n", _bagslotnum, _bagitem.ItemCount, _bagitem.Name, _TMpoti) ; end;
				elseif ( consumable ) and (( consumable.Type == "health" ) or ( consumable.Type == "hot" )) and ( consumable.Level <= player.Level ) then
					_THpoti = _THpoti + _bagitem.ItemCount;
					_total = _THpoti;
					-- if _showdebug then printf(" DEBUGa:: slot:%d :%s. Total: %d\n", item, _bagitem.Name, _THpoti) ; end;
				elseif ( consumable ) and ( consumable.Type == "arrow_quiver" ) and ( consumable.Level <= player.Level ) then
					_quivers = _quivers + _bagitem.ItemCount;
					_total = _quivers;
					-- if _showdebug then printf(" DEBUGa:: slot:%d :%s. Total=%d\n", _bagslotnum, _bagitem.Name, _quivers) ; end;
				elseif ( _bagitemtype == 3 ) and ( _bagitem.Available ) and not ( _bagitem.Empty ) then
					_productionmaterials = _productionmaterials + 1;
					_total = _productionmaterials;
					if _showdebug then printf(" DEBUGg:: slot:%d :%s. Total=%d\n", _bagslotnum, _bagitem.Name, _recipes) ; end;					
				elseif ( _bagitemtype == 4 ) and (_bagitem.Quality > 1) and ( _bagitem.Available ) and not ( _bagitem.Empty ) then
					_recipes = _recipes + 1;
					_total = _recipes;
					if _showdebug then printf(" DEBUGg:: slot:%d :%s. Total=%d\n", _bagslotnum, _bagitem.Name, _recipes) ; end;
				elseif ( _bagitemtype == 10 ) and ( _bagitem.Available ) and not ( _bagitem.Empty )then
					_questitems = _questitems + 1;
					_total = _questitems
					-- if _showdebug then printf(" DEBUGa:: slot:%d :%s. Total=%d\n", _bagslotnum, _bagitem.Name, _questitems) ; end;
				end
				if _showdebug and _showbagitemsdebug then
					if ( _bagitem.Available ) and not ( _bagitem.Empty ) then 
						printf(" DEBUGg::slot:%d %s. Type:%s", _bagslotnum, _bagitem.Name, _bagitemtype) ;
						if ( consumable ) then 
							printf(" cnsbl:%s Tot%d\n", consumable.Type, _total ) 
						else 
							printf("\n"); 
						end;
					end;
				end;
			end	
			if _showdebug then printf(" DEBUGg:: Returning mana%d health%d quivers%d recipes%d questitems%d\n", _TMpoti, _THpoti, _quivers, _recipes, _questitems) ; end;
			return _TMpoti, _THpoti, _quivers, _recipes, _productionmaterials, _questitems;
		elseif ( _whatstat == "dura" ) then -- Get the durability of the main weapon
			local _dura = inventory:getMainHandDurability();
			return _dura;
		elseif ( _whatstat == "freeslots" ) then -- Get the number of empty bag slots
			local _freeslots = inventory:itemTotalCount(0);
			return _freeslots;
		elseif ( _whatstat == "prilvl" ) then -- Get the level of the primary class
			return _plevel;
		elseif ( _whatstat == "seclvl" ) then -- Get the level of the secondary class
			return _slevel;
		elseif ( _whatstat == "questcount" ) then -- Get the number of remaining dailies left
			return _dailyquestsleft;
		elseif ( _whatstat == "classdifference" ) then
			if _showdebug then printf(" DEBUGg:: Classdifference:%d Level:Pri%dSec%d\n", _classdifference, _plevel, _slevel ) ; end;
			return _classdifference;
		-- elseif ( _whatstat == "dailyquest" ) then
			-- if _showdebug then printf(" DEBUGg:: dailyquestsperday:%d- dailyquestcount:%d= dailyquestsleft:%d Lvl:%d\n", _dailyquestsperday, _dailyquestcount,_dailyquestsleft, _plevel ) ; end;
			-- return _dailyquestsleft;
		elseif ( _whatstat == "priclass" ) or ( _whatstat == "secclass") then -- Get the Name of the primary or secondary class
			player:update()
			
			if ( _whatstat == "priclass" ) then
				_class = player.Class1;
			elseif ( _whatstat == "secclass" ) then
				_class = player.Class2;
			else
				printf(" error: whatstatnoclass, unknown class %s. whatstat %s \n", _class, _whatstat);
			end;
			
			if ( _class == 1 ) then
				_pclass = "Warrior";
				return _pclass;
			elseif ( _class == 2 ) then
				_pclass = "Scout";
				return _pclass;
			elseif ( _class == 3 ) then
				_pclass = "Rogue";
				return _pclass;
			elseif ( _class == 4 ) then
				_pclass = "Mage";
				return _pclass;
			elseif ( _class == 5 ) then
				_pclass = "Priest";
				return _pclass;
			elseif ( _class == 6 ) then
				_pclass = "Knight";
				return _pclass;
			elseif ( _pclass == "Unknown" ) then
				printf(" class %s unknown \n",_class);
				return _pclass;
			end;

		else
			local staterror = "error getting stat, no match found";
			return staterror;
		end;			
		return false
	end
	
	
	-- Function to swap primary and secondary classes at the house maid. (not yet dealing with 3rd class)
	function SwapClass(_housemaid)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGs:: Starting  SwapClass \n") ; end;
		
		player:update();
		
		if free_counter2 == nil then free_counter2 = 0; end;
		free_counter2 = free_counter2 + 1;
		local _pclass = GetStat("priclass");
		local _sclass = GetStat("secclass");
		local _plevel = GetStat("prilvl");
		local _slevel = GetStat("seclvl");
		local _empty = inventory:findItem(0,"bags")
		printf(" Changing classes: Current class/level: "); cprintf(cli.lightblue, "%s", _pclass); printf("(%d) ", _plevel);
		cprintf(cli.green, "%s", _sclass); printf("(%d). Housemaid visits: %d \n", _slevel, free_counter2 );
		PrintLine("lightblue");
		player:target_NPC(_housemaid);
		sendMacro("ChoiceOption(3);");
		yrest(5000);
		sendMacro("ExchangeClass(EXCHANGECLASS_SUBCLASS, EXCHANGECLASS_MAINCLASS)");
		yrest(5000);
		player:update();
		_pclass = GetStat("priclass");
		_sclass = GetStat("secclass");
		_plevel = GetStat("prilvl");
		_slevel = GetStat("seclvl");
		printf(" Now current class/level is: "); cprintf(cli.lightblue, "%s", _pclass); printf("(%d) ", _plevel);
		cprintf(cli.green, "%s", _sclass); printf("(%d) \n", _slevel);
		-- remove any ammo in ammo slot, so the correct level ammo can be reloaded, dont want to have too high a level arrows in hand and unable to use them
		
		if _pclass == "Scout" or _pclass == "Rogue" or _sclass == "Scout" or _sclass == "Rogue" then
			RoMScript("EquipItem(10,".._empty.BagId..")")
			LoadWaypoints("todoweaponsvendor");
		end
		return false
	end
	
	
	-- Function to register yourself at the Teleporter "Snoop the Stubborn"
	function TeleSnoop()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting TeleSnoop  \n") ; end;
		
		if _countertransporter == nil then
			_countertransporter = 1; 
		else
			_countertransporter = _countertransporter + 1;
		end
		printf(" Teleporter Snoop the Stubborn visits: %d \n", _countertransporter );
		player:target_NPC("Snoop the Stubborn");
		yrest(500);
		sendMacro("ChoiceOption(2);");
		yrest(500);
		player:update();
		yrest(500);
		return false
	end
	
	
		
	-- Function to rent a Horse. _type can be "2h" for 2 hour horse or nil for the first mount it finds in your bag.
	function RentHorse(_merchant, _type)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGr:: Starting RentHorse  \n") ; end;
		
		if _counterhorsesrented == nil then _counterhorsesrented = 0; end;
		_counterhorsesrented = _counterhorsesrented + 1;
		printf(" Time to get a horse. Horse Vendor visits: %d\n", _counterhorsesrented);
		PrintLine();
		player:target_NPC(_merchant);
		yrest(500);
		if _type == "2h" then
			sendMacro("ChoiceOption(4);");
		else
			sendMacro("ChoiceOption(2);");
		end
		yrest(2000);
		sendMacro("StaticPopup_EnterPressed(StaticPopup1);StaticPopup1:Hide();");
		yrest(2000);
		player:update();
		yrest(2000);
		inventory:update();
		yrest(2000);
		MountHorse();
		return false		
	end
	
	
	-- Function to find the first mount in your bag and mount it.
	function MountHorse()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGm:: Starting MountHorse  \n") ; end;
		
		local _availablemount = "none"
		if( not player.Mounted ) then 
			for item = 60, 120, 1 do -- for each bag slot
				local _bagitem = inventory.BagSlot[item];
				local _bagslotnum = ((item) - 60);
				if _showfunctiondebug and _bagitem.Name ~= "<EMPTY>" then printf(" DEBUGm:: slot%d: %s  \n", _bagslotnum, _bagitem.Name) ; end;
				if string.find(_bagitem.Name, "Horse") or string.find(_bagitem.Name, "Warhorse") then
					_availablemount = _bagitem.Name
					printf(" Found Mount, slot%d: %s\n", _bagslotnum, _bagitem.Name)
					inventory:useItem(_bagitem.Name) 
					printf(" Mounting %s\n", _bagitem.Name)
					break
				end
			end
			if _availablemount == "none" then
				printf(" There is no avaiable Mount, so you are just going to have to run.\n")
			end
			yrest(6000);
		else
			printf(" Already on a Mount, ready to ride.\n")
		end

		player:update();
		return false
	end
	
	
	-- Function to use an NPC teleporter. Need to provide NPC name and teleport menu option(s)
	function UseTeleporter(_merchant, _option1, _option2)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGu:: Starting UseTeleporter  \n") ; end;
		
		player:target_NPC(_merchant);
		sendMacro("ChoiceOption(" .. _option1 .. ");");
		
		if _option2 ~= nil then
			yrest(1000);
			sendMacro("ChoiceOption(" .. _option2 .. ");");
		end	
		if _merchant == "Snoop the Stubborn" then
			yrest(2000);
			sendMacro("StaticPopup_EnterPressed(StaticPopup1);StaticPopup1:Hide();");
			yrest(2000);
		end;
		-- waitForLoadingScreen()
		player:update();
		yrest(5000);
		player:update();
		yrest(5000);
		player:update();
		return false
	end
	
	
	-- Fuction to use a specified Skill eg: "recall" when you get stuck somewhere
	function UseASkill(_skill,_planb)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGu:: Starting UseASkill   \n") ; end;
		
		player:update()
		
		if ( _skill == "recall" ) then
			local cooldown, remaining = sendMacro("GetSkillCooldown(1,2);")
			player:update()
            local X = player.X
            local Z = player.Z
            
			if remaining > 1 then -- recall is on cooldown
				if not _planb or _planb == "wait" then
					printf(" Starting To Cast Recall, but may need to wait a bit for cooldown   \n")
					repeat
						sendMacro("UseSkill(1,2);");
                        yrest(1000)
                        player:update()
                    until memoryReadBytePtr(getProc(), addresses.loadingScreenPtr, addresses.loadingScreen_offset) ~= 0 or 
							distance(player.X, player.Z, X, Z) > 100 or keyPressedLocal(settings.hotkeys.START_BOT.key)
				elseif _planb == "repair" then
					printf(" Starting To Cast Recall, but still on cooldown, so heading to Merchant  \n")
					GoToTag("trvltorepair");
				elseif _planb == "run" then
					Run();
				elseif _planb == "travel" then
					Travel();
				elseif _planb == "logout" then
					RoMScript("Logout();"); --just logged out instead				
                    error("Recall was on cooldown, so logged out.")   
                end
			else
				printf(" Starting To Cast Recall   \n")
				repeat
					sendMacro("UseSkill(1,2);");
					yrest(1000)
					player:update()
				until memoryReadBytePtr(getProc(), addresses.loadingScreenPtr, addresses.loadingScreen_offset) ~= 0 or 
						distance(player.X, player.Z, X, Z) > 100 or keyPressedLocal(settings.hotkeys.START_BOT.key)
				player:update();
			end
		elseif ( _skill == "blackhorse" ) then -- 15min Black Horse
			printf(" Starting To Cast Mount   \n")
			inventory:useItem("Black Horse (15 min)")
			player:rest(10);
		else
			cprintf(cli.yellow, "Error: Unknown Skill %s", _skill);
		end;
		yrest(10000)
        player:update()
		return false
	end
	
	
	-- Function created primarily to check if toon was on horse, to stop from casting while on horse and waypoint type was travel
	-- think this is now obsolete with an updated mmBot files/travel function
	function BuffCheck(_buffname)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGb:: Starting  BuffCheck \n") ; end;
		if _showdebug then printf(" DEBUGb:: Buffname=%s \n", _buffname) ; end;
		
		if ( _buffname == "Black Horse" ) then
			local _waypointtype = player.Current_waypoint_type;
			if _showdebug then printf(" DEBUGb:: player.Current_waypoint_type=%s \n", _waypointtype) ; end;
			
			if ( player.Current_waypoint_type == WPT_TRAVEL ) and ( player:hasBuff("Black Horse") ) then
				if _showdebug then printf(" DEBUGb:: Inside waypoint and hasbuff, return false, do not cast spell. \n") ; end;
				return false;
			else 
				if _showdebug then printf(" DEBUGb:: Outside waypoint and hasbuff, return true, cast spell. \n") ; end;
				return true;
			end;
		end;
	end
	
	
	-- Function to remove a buff. Copied from forum, so no creadit to me.
	function CancelBuff(buffname)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting  CancelBuff \n") ; end;

		if buffname == nil then
			cprintf(cli.yellow," No buff specified. Please use 'CancelBuff(buffname)'.\n")
			return false
		end
		local buffnum=1
		local buff=RoMScript("UnitBuff('player',"..buffnum..")");
		while buff ~= nil do
			if buff == buffname then
				sendMacro("CancelPlayerBuff("..buffnum..");")
				return true
			end
			buffnum=buffnum+1
			buff=RoMScript("UnitBuff('player',"..buffnum..")");
		end
		return false
	end
	
	
	-- Function used for debugging, will display the item types of all the items in the characters bag
	function DisplayItemTypes()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGd:: Starting DisplayItemTypes  \n") ; end;
		
		local _startslot = 60;
		local _finishslot = 120;
		local _playername = player.Name;
		PrintLine();
		printf(" Listing slot item types for player %s:\n", _playername);
		
		for item = _startslot, _finishslot, 1 do -- for each inventory
			local slotitem = inventory.BagSlot[item];
			local slotNumber = slotitem.SlotNumber - 60
			
			if  (slotitem.Available and not slotitem.Empty) then
				local _itemname = slotitem.Name;
				local _itemtype = slotitem.ObjType;
				local _itemsubtype = slotitem.ObjSubType;
				local _itemsubsubtype = slotitem.ObjSubSubType;
				local _itemid = slotitem.Id;
				printf(" Slot%02d: %02d:%02d:%02d: %d:%s \n", slotNumber, _itemtype, _itemsubtype, _itemsubsubtype, _itemid, _itemname);
			end
		end
		return false
	end
	
	
	-- Function to manage the todo list and send the toon off to the various places it needs to go
	-- mainly a way to navigate the towns or cities to get everything done before heading back out to grind
	function CheckToDoList(_location)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting CheckToDoList  \n") ; end;
		
		local _locallocation = _location
		local  _a, _farmthisarea = CheckDailyQuests(_locallocation);
		
		if ( _dotodolist == nil ) then
			UpdateToDoList(_locallocation);
		end;
		if _showdebug then printf(" DEBUGc:: _dotodolist:%d _getmanapotions:%d _gethealthpotions:%d _getquivers:%d _mailquestitems:%d _changechannel:%d _emptybagslots:%d_checklevel:%d \n", _dotodolist, _getmanapotions, _gethealthpotions, _getquivers, _mailquestitems, _changechannel, _emptybagslots, _checklevel) ; end;
		
		if _dotodolist == 1 then
			if _learnmonstercards == 1 then
				cprintf(cli.lightblue, " ToDo list item: Learn Monster Cards \n");
				LearnMonsterCards();
			end
			
			if _mailquestitems == 1 then
				cprintf(cli.lightblue, " ToDo list item: Send Quest Items at Mailbox \n");
				LoadWaypoints("todomailbox");
			elseif _mailrecipes == 1 then
				cprintf(cli.lightblue, " ToDo list item: Send Recipes at Mailbox \n");
				LoadWaypoints("todomailbox");
			elseif _mailblueitems == 1 then
				cprintf(cli.lightblue, " ToDo list item: Send Blue Items at Mailbox \n");
				LoadWaypoints("todomailbox");
			elseif _mailgreenitems == 1 then
				cprintf(cli.lightblue, " ToDo list item: Send Green Items at Mailbox \n");
				LoadWaypoints("todomailbox");
			elseif _mailrunes == 1 then
				cprintf(cli.lightblue, " ToDo list item: Send Runes at Mailbox \n");
				LoadWaypoints("todomailbox");
			elseif _mailproductionmaterials == 1 then
				cprintf(cli.lightblue, " ToDo list item: Send Production Materials at Mailbox \n");
				LoadWaypoints("todomailbox");
			elseif _getquivers == 1 then
				cprintf(cli.lightblue, " ToDo list item: go Buy some Quivers \n");
				LoadWaypoints("todoweaponsvendor");
			elseif _doquest == 1 then
				cprintf(cli.lightblue, " ToDo list item: Do Quest \n");
				LoadWaypoints("todoquest");
			elseif _dodailyquest == 1 then
				cprintf(cli.lightblue, " ToDo list item: Do Daily Quest \n");
				LoadWaypoints("tododailyquest");
			elseif _bankitem == 1 then
				cprintf(cli.lightblue, " ToDo list item: Visit Bank \n");
				LoadWaypoints("todobank");
			elseif _swapclass == 1 then
				cprintf(cli.lightblue, " ToDo list item: Swap Class at Housemaid \n");
				LoadWaypoints("todohousemaid");
			elseif _gethorse == 1 then
				cprintf(cli.lightblue, " ToDo list item: Rent Horse \n");
				LoadWaypoints("todohorsevendor");
			elseif _aucionhousevisit == 1 then
				cprintf(cli.lightblue, " ToDo list item: Check Auctionhouse items \n");
				LoadWaypoints("todoauctionhouse");
			elseif _repairequipment == 1 then
				cprintf(cli.lightblue, " ToDo list item: Check Weapon Durability \n");
				LoadWaypoints("todogeneralmerchant");
			elseif _getmanapotions == 1 then
				cprintf(cli.lightblue, " ToDo list item: Get Mana Potions \n");
				LoadWaypoints("todogeneralmerchant");
			elseif _gethealthpotions == 1 then
				cprintf(cli.lightblue, " ToDo list item: Get Health Potions \n");
				LoadWaypoints("todogeneralmerchant");
			elseif _emptybagslots == 1 then -- this should be 1 so have to go to Merchant at least once
				cprintf(cli.lightblue, " ToDo list item: Check Bags \n");
				LoadWaypoints("todogeneralmerchant");
			else
				if ( _emptybagslots == 0 ) and ( _changechannel == 1 ) then
					cprintf(cli.lightblue, " ToDo list item: Change Channel \n");
					ChangeChannel();
				end
				
				if _farmdailyquestitems == 1 then
					cprintf(cli.lightblue, " ToDo list item: Farm Daily Quest Items \n");
					LoadWaypoints(_farmthisarea);
				elseif ( _emptybagslots == 0 ) and _checklevel == 1 then
					cprintf(cli.lightblue, " ToDo list item: Check Level \n");
					CheckLevel(_locallocation);
				else
					printf(" Just checked the TODO list and there seems to be nothing left to do. \n");
					LoadWaypoints("todogeneralmerchant");
				end
			end
		else
			printf(" The ToDo list is empty\n");			
		end
	end
	
	
	-- Function to check many things and determine what things need to go onto the toons todo list.
	function UpdateToDoList(_location, _listoption)
		local _locallocation = _location;
		if _showfunctiondebug then cprintf(cli.blue," DEBUGu:: Starting UpdateToDoList." ) ; 
			if _locallocation ~= nil then
				printf(" Location: %s \n", _locallocation);	
			else
				printf("\n");
			end
		end;
		
		player:update()
		inventory:update()
		
		local _TMpoti, _THpoti, _quivers, _recipes, _productionmaterials, _questitems = GetStat("todo");
		local _candothisdaily, _farmherefordaily = CheckDailyQuests(_location);	
		local _dothisquest = CheckQuestList();
		local _doquest
		
		
		if _showdebug then 
			printf(" DEBUGu:: mana%d health%d quivers%d recipes%d productionmaterials%d questitems%d\n", _TMpoti, _THpoti, _quivers, _recipes, _productionmaterials, _questitems );
		end;
		
		-- ***   check if change channel is to be done   ***
		if ( _dotodolist == nil ) or ( _listoption == "newlist" ) then
			SetProfileOptions(_locallocation);	-- Setting profile options like mana and healing so at lower levels, the bot can buy fewer potions (due to limited money)
			_dotodolist = 1;
			_changechannel = 1;
			_checklevel = 1;
			_emptybagslots = 1;
			_learnmonstercards = 1;	
			if _showdebug then printf(" DEBUGu:: Setting Variables dotodolist, changechannel, checklevel, emptybagslots and learnmonstercards to 1 \n") ; end;			
		end;
		

		-- ***   check if there are items to bank   ***
		if _bankitem ~= 1 then
			BankItem("checkonly");
			if _bankitem == 1 then
				cprintf(cli.lightblue, " Adding BankItem to the todo list.\n");
			end
		elseif _bankitem == 1 then
			BankItem("checkonly");
			if _bankitem == 1 then
				cprintf(cli.lightblue, " Still have BankItem on the todo list.\n");
			else
				cprintf(cli.lightblue, " Crossing BankItem off the todo list.\n");
			end
		end
			if _showdebug then printf(" DEBUGu:: _bankitem = %d \n", _bankitem) ; end;
			
		-- ***   check if the secondary class if more than 1 level different   ***
		if _swapclass ~= 1 and (GetStat("classdifference")) > 1 then
			cprintf(cli.lightblue, " Adding Swap Class to the todo list.\n");
			_swapclass = 1; 
		elseif _swapclass == 1 and (GetStat("classdifference")) > 1 then
			cprintf(cli.lightblue, " Still have Swap Class on the todo list.\n");
			_swapclass = 1; 
		elseif  _swapclass == 1 then 
			cprintf(cli.lightblue, " Crossing Swap Class off the todo list.\n");
			_swapclass = 0;
		else 
			_swapclass = 0;
		end
			if _showdebug then printf(" DEBUGu:: _swapclass = %d \n", _swapclass) ; end;
		
		-- ***   check if there are possible Quests to do   ***
		if _doquest ~= 1 and dothisquest ~= "none" then
			cprintf(cli.lightblue, " Adding Do Quest to the todo list.\n");
			_doquest = 1; 
		elseif _doquest == 1 and dothisquest ~= "none" then
			cprintf(cli.lightblue, " Still have Do Quest on the todo list.\n");
			_doquest = 1; 
		elseif _doquest == 1 and dothisquest == "none" then
			cprintf(cli.lightblue, " Crossing Do Quest off the todo list.\n");
			_doquest = 0;
		else 
			_doquest = 0;
		end
			if _showdebug then printf(" DEBUGu:: _doquest = %d dothisquest:%s \n", _doquest, _dothisquest) ; end;
			
		-- ***   check if there are possible Daily Quests to do   ***
		if _dodailyquest ~= 1 and _candothisdaily ~= "none" then
			cprintf(cli.lightblue, " Adding Do Daily Quest to the todo list.\n");
			_dodailyquest = 1; 
		elseif _dodailyquest == 1 and _candothisdaily ~= "none" then
			cprintf(cli.lightblue, " Still have Do Daily quest on the todo list.\n");
			_dodailyquest = 1; 
		elseif _dodailyquest == 1 and _candothisdaily == "none" then
			cprintf(cli.lightblue, " Crossing Do Daily Quest off the todo list.\n");
			_dodailyquest = 0;
		else 
			_dodailyquest = 0;
		end
			if _showdebug then printf(" DEBUGu:: _dodailyquest = %d _candothisdaily:%s \n", _dodailyquest, _candothisdaily) ; end;
			
		-- ***   check if there are possible Dailies Items to Farm   ***
		if _farmdailyquestitems ~= 1 and _farmherefordaily ~= "none" then
			cprintf(cli.lightblue, " Adding Farm Daily Quest Items to the todo list.\n");
			_farmdailyquestitems = 1; 
		elseif _farmdailyquestitems == 1 and _farmherefordaily ~= "none" then
			cprintf(cli.lightblue, " Still have Farm Daily Quest Items on the todo list.\n");
			_farmdailyquestitems = 1; 
		elseif _farmdailyquestitems == 1 and _farmherefordaily == "none" then
			cprintf(cli.lightblue, " Crossing Farm Daily Quest Items off the todo list.\n");
			_farmdailyquestitems = 0;
		else 
			_farmdailyquestitems = 0;
		end
			if _showdebug then printf(" DEBUGu:: _farmdailyquestitems = %d _farmherefordaily:%s \n", _farmdailyquestitems, _farmherefordaily) ; end;
			
		-- ***   check level of mana potions   ***
		if _getmanapotions ~= 1 and settings.profile.options.MANA_POTION > _TMpoti then
			cprintf(cli.lightblue, " Adding Mana Potions to the todo list.\n");
			_getmanapotions = 1; 
		elseif _getmanapotions == 1 and settings.profile.options.MANA_POTION > _TMpoti then 
			cprintf(cli.lightblue, " Still have Mana Potions on the todo list .\n");
			_getmanapotions = 1;
		elseif _getmanapotions == 1 and _TMpoti >= settings.profile.options.MANA_POTION then 
			cprintf(cli.lightblue, " Crossing Mana Potions off the todo list.\n");
			_getmanapotions = 0;
		else 
			_getmanapotions = 0;
		end
			if _showdebug then printf(" DEBUGu:: _getmanapotions = %d \n", _getmanapotions) ; end;
			
		-- ***   check level of health potions   ***
		if _gethealthpotions ~= 1 and settings.profile.options.HEALING_POTION > _THpoti then
			cprintf(cli.lightblue, " Adding Health Potions to the todo list.\n");
			_gethealthpotions = 1; 
		elseif _gethealthpotions == 1 and settings.profile.options.HEALING_POTION > _THpoti then 
			cprintf(cli.lightblue, " Still have Health Potions on the todo list .\n");
			_gethealthpotions = 1;
		elseif _gethealthpotions == 1 and _THpoti >= settings.profile.options.HEALING_POTION then 
			cprintf(cli.lightblue, " Crossing Healing Potions off the todo list.\n");
			_gethealthpotions = 0;
		else
			_gethealthpotions = 0;
		end
			if _showdebug then printf(" DEBUGu:: _gethealthpotions = %d \n", _gethealthpotions) ; end;
			
		-- ***   check quest items to mail   ***
		if  _mailquestitems ~= 1 and _questitems > settings.profile.options.MAIL_QUEST_ITEMS and _farmdailyquestitems ~= 1  and _dodailyquest ~= 1 then
			cprintf(cli.lightblue, " Adding Mail Quest Items to the todo list.\n");
			_mailquestitems = 1; 
		elseif _mailquestitems == 1 and _questitems > settings.profile.options.MAIL_QUEST_ITEMS then
			cprintf(cli.lightblue, " Still have Mail Quest Items on the todo list.\n");
			_mailquestitems = 1; 
		elseif  _mailquestitems == 1 then 
			cprintf(cli.lightblue, " Crossing Mail Quest Items off the todo list.\n");
			_mailquestitems = 0;
		else 
			_mailquestitems = 0;
		end
			if _showdebug then printf(" DEBUGu:: _mailquestitems = %d \n", _mailquestitems) ; end;
			
		-- ***   check recipes to mail   ***
		if _mailrecipes ~= 1 and _recipes > settings.profile.options.MAIL_RECIPES then
			cprintf(cli.lightblue, " Adding Mail Recipes to the todo list.\n");
			_mailrecipes = 1; 
		elseif _mailrecipes == 1 and _recipes > settings.profile.options.MAIL_RECIPES then
			cprintf(cli.lightblue, " Still have Mail Recipes on the todo list.\n");
			_mailrecipes = 1; 
		elseif  _mailrecipes == 1 then 
			cprintf(cli.lightblue, " Crossing Mail Recipes off the todo list.\n");
			_mailrecipes = 0;
		else 
			_mailrecipes = 0;
		end
			if _showdebug then printf(" DEBUGu:: _mailrecipes = %d \n", _mailrecipes) ; end;
			
		-- ***   check Production Materials to mail   ***
		if _mailproductionmaterials ~= 1 and _productionmaterials >  settings.profile.options.MAIL_PRODUCTION_MATERIALS then
			cprintf(cli.lightblue, " Adding Mail Production Materials to the todo list.\n");
			_mailproductionmaterials = 1; 
		elseif _mailproductionmaterials == 1 and _productionmaterials > settings.profile.options.MAIL_PRODUCTION_MATERIALS then
			cprintf(cli.lightblue, " Still have Mail Production Materials on the todo list.\n");
			_mailproductionmaterials = 1; 
		elseif  _mailproductionmaterials == 1 then 
			cprintf(cli.lightblue, " Crossing Mail Production Materials off the todo list.\n");
			_mailproductionmaterials = 0;
		else 
			_mailproductionmaterials = 0;
		end
			if _showdebug then printf(" DEBUGu:: _mailproductionmaterials = %d \n", _mailproductionmaterials) ; end;		
			
		-- ***   check level of quivers   ***
		if _getquivers ~= 1 and settings.profile.options.ARROW_QUIVER > _quivers then
			cprintf(cli.lightblue, " Adding Get Quivers to the todo list.\n");
			_getquivers = 1; 
		elseif _getquivers == 1 and settings.profile.options.ARROW_QUIVER > _quivers then
			cprintf(cli.lightblue, " Still have Get Quivers on the todo list.\n");
			_getquivers = 1;
		elseif _getquivers == 1 and _quivers >= settings.profile.options.ARROW_QUIVER then 
			cprintf(cli.lightblue, " Crossing Get Quivers off the todo list.\n");
			_getquivers = 0;
		else  
			_getquivers = 0;
		end
			if _showdebug then printf(" DEBUGu:: _getquivers = %d \n", _getquivers) ; end;
			if _showdebug then printf(" DEBUGu:: _checklevel = %d \n", _checklevel) ; end;

	end
	
	-- Function to Send items using rock5 UMM mail mod. To keep bags clear of no sale-able items
	function SendMail(_location)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGs:: Starting SendMail  \n") ; end;
		
		local _locallocation
		local _mailrecipient1 = ( player.Name .. "pa");
		
		if ( _dotodolist == nil ) then
			UpdateToDoList(_locallocation);
		end;

		if customsettings.options.MAIL_RECIPIENT1 ~= "" then
			local _mailrecipient1 = customsettings.options.MAIL_RECIPIENT1
		end
		local _mailrecipient2 = customsettings.options.MAIL_RECIPIENT2 or ( player.Name .. "pa");
		local _mailrecipient3 = customsettings.options.MAIL_RECIPIENT3 or ( player.Name .. "pa");
		local _mailrecipient4 = customsettings.options.MAIL_RECIPIENT4 or ( player.Name .. "pa");
		yrest(150);
		inventory:update();
		yrest(150);
		-- Send Cards to _mailrecipient2
		printf(" Sending Cards to %s  \n", _mailrecipient1)
		UMM_SendAdvanced(_mailrecipient1, nil,nil,nil,nil, "Monster Cards");
		-- yrest(10000);
		
		-- Send Daily Quest Items to _mailrecipient1
		if ( _dodailyquest ~= 1 and _farmdailyquestitems ~= 1 ) then
			printf(" Sending Daily Quest Items to %s  \n", _mailrecipient1)
			UMM_SendAdvanced(_mailrecipient1, nil,nil,nil,nil, "Quest Items");
			yrest(10000);
		end
		-- yrest(10000);
		
		-- Send Recipes to _mailrecipient2
		printf(" Sending Recipes to %s \n", _mailrecipient1)
		UMM_SendAdvanced(_mailrecipient1, nil,2,nil,nil, "Recipes");
		-- yrest(10000);
		
		-- Send Production Materials to _mailrecipient2
		printf(" Sending Production Materials to %s \n", _mailrecipient1)
		UMM_SendAdvanced(_mailrecipient1, nil,nil,nil,nil, "Materials");
		-- yrest(10000);
		
		-- Send Blue items to _mailrecipient1
		printf(" Sending Blue items to %s  \n", _mailrecipient1)
		UMM_SendAdvanced(_mailrecipient1, nil,2,nil,1);
		-- yrest(10000);
		
		-- Send Runes to _mailrecipient1
		printf(" Sending Runes to %s  \n", _mailrecipient1)
		UMM_SendAdvanced(_mailrecipient1, nil,nil,nil,nil,"Runes");
		-- yrest(10000);
		
		-- Send Stacks of Guild Runes to _mailrecipient1
		printf(" Sending Stacks of Guild Runes to %s  \n", _mailrecipient1)
		UMM_SendAdvanced(_mailrecipient1, "Guild Rune",nil,nil,nil,nil,nil,nil,nil, "max");
		-- yrest(10000);
	end
	
	-- Function to identify what is the best quest to do, 
	-- considering player level, location and quest items available
	-- this function is not in working order, but working on it shortly.
	function CheckQuests()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting CheckQuests  \n") ; end;
		
		local _plevel = GetStat("prilvl");
		local _dothisquest = "none";

		printf(" Cant do any Quests at the moment, function not finished \n");
		
		-- else
			-- printf(" Cant do any quests at the moment, have done %d today already \n",_dailyquestcount);
		-- end
		return _dothisquest;
	end
	
	-- Function to identify what is the best daily to do, 
	-- considering player level, location and quest items available
	function CheckDailyQuests(_location)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGd:: Starting CheckDailyQuests  \n") ; end;
		
		local _locallocation = _location
		local _plevel = GetStat("prilvl");
		local _dothisdaily = "none";
		
		local _farmthisitem = "none";
		local _dailyquestcount, _dailyquestsperday = RoMScript("Daily_count()")
		_dailyquestsleft = ( _dailyquestsperday - _dailyquestcount );
		
		if _showdebug then printf(" DEBUGc:: dailyquestsperday:%d - dailyquestcount:%d = dailyquestsleft:%d Lvl:%d\n", _dailyquestsperday, _dailyquestcount,_dailyquestsleft, _plevel ) ; end;
		
		if _dailyquestsleft > 0 then
			-- _dodailyquest = _dodailyquest or 1
			-- Level:47, Start:Obsidian Stronghold Buletin Board, 
			-- Quest:"A Nightmare", Requires: 20x "Kal Turok King Head" 
			if player.Level > 46 then
				if inventory:getItemCount("Kal Turok King Head") >= ( 20 *  _dailyquestsleft ) then
					printf(" Can do * A Nightmare * using 20x Kal Turok King Head  \n");
					_dothisdaily = "dailyOS_ANightmare";
				else 
					printf(" Need more items to complete * A Nightmare * need 20x Kal Turok King Head  \n");
					_farmthisitem = "aroundants2";
				end
			-- Level:43, Start:Obsidian Stronghold Buletin Board, 
			-- Quest:"Never Too Late to Mend", Requires: 15x "Stored Ore Crystal" 
			elseif player.Level > 41 then
				if inventory:getItemCount("Stored Ore Crystal") >= ( 15 *  _dailyquestsleft ) then
					printf(" Can do * Never Too Late to Mend * using 15x Stored Ore Crystal  \n");
					_dothisdaily = "dailyOS_NeverTooLateToMend";
				else
					printf(" Need more items to complete * Never Too Late to Mend * need 15x Stored Ore Crystal  \n");
					_farmthisitem = "aroundscorpions4";
				end
			-- Level:34, Start:Harf Trading Post Buletin Board, 
			-- Quest:"Minotaur Trinkets", Requires: 10x "Minotaur Ornament" 
			elseif player.Level > 35 and 38 > player.Level then
				if inventory:getItemCount("Minotaur Ornament") >= ( 10 *  _dailyquestsleft ) then
					printf(" Can do * Minotaur Trinkets * using 10x Minotaur Ornament  \n");
					_dothisdaily = "dailyHTP_MinotaurTrinkets";
				elseif _locallocation == "Loca Roco" then
						printf(" Need more items to complete * Minotaur Trinkets * need 10x Minotaur Ornament  \n");
						_farmthisitem = "aroundminotaurs";
				elseif _locallocation == "Jacques" then
						printf(" Need more items to complete * Minotaur Trinkets * need 10x Minotaur Ornament, need to head to FrostWood  \n");
						_farmthisitem = "travelfrostwood";
				end
			-- Level:33, Start:Harf Trading Post Buletin Board, 
			-- Quest:"The Cyclops Menace", Requires: 15x "Cyclops Horn" 
			elseif player.Level > 34 and 36 > player.Level then
				if inventory:getItemCount("Cyclops Horn") >= ( 15 *  _dailyquestsleft ) then
					printf(" Can do * The Cyclops Menace * using 15x Cyclops Horn  \n");
					_dothisdaily = "dailyHTP_TheCyclopsMenace";
				elseif _locallocation == "Loca Roco" then
						printf(" Need more items to complete * The Cyclops Menace * need 15x Cyclops Horn  \n");
						_farmthisitem = "aroundcyclops";
				elseif _locallocation == "Jacques" then
						printf(" Need more items to complete * The Cyclops Menace * need 15x Cyclops Horn, need to head to FrostWood  \n");
						_farmthisitem = "travelfrostwood";
				end
			-- Level:31, Start:Harf Trading Post Buletin Board, 
			-- Quest:"Strong Medicine", Requires: 10x "High Quality Antler" 
			elseif player.Level > 30 and 34 > player.Level then
				if inventory:getItemCount("High Quality Antler") >= ( 10 *  _dailyquestsleft ) then
					printf(" Can do * Strong Medicine * using 10x High Quality Antler  \n");
					_dothisdaily = "dailyHTP_StrongMedicine";
				elseif 
					_locallocation == "Jacques" then
					printf(" Need more items to complete * Strong Medicine * need 10x High Quality Antler  \n");
					_farmthisitem = "aroundreindeer";
				end
			-- Level:29, Start:Silverfall Buletin Board, 
			-- Quest:"Demon Vine", Requires: 10x "Demon Vine Seed" 
			elseif player.Level > 28 and 31 > player.Level then
				if inventory:getItemCount("Demon Vine Seed") >= ( 10 *  _dailyquestsleft ) then
					printf(" Can do * Demon Vine * using 10x Demon Vine Seed  \n");
					_dothisdaily = "dailySF_DemonVine";
				elseif 
					_locallocation == "Miles" then
					printf(" Need more items to complete * Demon Vine * need 10x Demon Vine Seed  \n");
					_farmthisitem = "aroundflowers";
				end
			-- Level:27, Start:Silverfall Buletin Board, 
			-- Quest:"Ents Dead Branches", Requires: 10x "Ent's Dead Branch" 
			elseif player.Level > 26 and 30 > player.Level then
				if inventory:getItemCount("Ent's Dead Branch") >= (10 *  _dailyquestsleft ) then
					printf(" Can do * Ents Dead Branches * using 10x Ent's Dead Branch  \n");
					_dothisdaily = "dailySF_EntsDeadBranches";
				elseif 
					_locallocation == "Miles" then
					printf(" Need more items to complete * Ents Dead Branches * need 10x Ent's Dead Branch  \n");
					_farmthisitem = "aroundents";
				end
			-- Level:21, Start:Silverfall Buletin Board, 
			-- Quest:"Enduring Armor", Requires: 10x "Anteater Scale" 
			elseif player.Level > 20 and 27 > player.Level then
				if inventory:getItemCount("Anteater Scale") >= ( 10 *  _dailyquestsleft ) then
					printf(" Can do * Enduring Armor * using 10x Anteater Scales  \n");
					_dothisdaily = "dailySF_EnduringArmor";
				elseif 
					_locallocation == "Miles" then
					printf(" Need more items to complete * Enduring Armor * need 10x Anteater Scales  \n");
					_farmthisitem = "aroundanteaters";
				end
			-- Level:17, Start:Varanas City West Buletin Board, 
			-- Quest:"An Ancient Inheritance", Requires: 10x "Ancient Stone Slab" 
			elseif player.Level > 16 and 19 > player.Level then
				if inventory:getItemCount("Ancient Stone Slab") >= ( 10 *  _dailyquestsleft ) then
					printf(" Can do * An Ancient Inheritance * using 10x Ancient Stone Slab  \n");
					_dothisdaily = "dailyVCW_AnAncientInheritance";
				else
					printf(" Need more items to complete * An Ancient Inheritance * need 10x Ancient Stone Slab  \n");
					_farmthisitem = "aroundtagena";
				end
			else 
				printf(" Cant do any Daily Quests at the moment, not enough items \n");
			end			
		else
			printf(" Cant do any Daily Quests at the moment, have done %d today already \n",_dailyquestcount);
		end
		return _dothisdaily, _farmthisitem;
	end
	
	-- Function to load the daily quest that "CheckDailyQuests()" identified as the appropriate quest to do.
	function DoDailyQuest(_location)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGd:: Starting DoDailyQuest()  \n") ; end;
		
		local _locallocation = _location
		local _dothisdaily = CheckDailyQuests(_locallocation);
		
		if _dothisdaily ~= "none" and _dothisdaily ~= nil then
			yrest(150);
			inventory:update();
			yrest(150);
			if 2 > inventory:itemTotalCount(0) then
				printf(" Can't do any daily quests because bags are full, heading to empty bags.  \n");
				LoadWaypoints("todoGeneralMerchant");
			else
				LoadWaypoints(_dothisdaily)
			end;
		else
			printf(" Can't do any daily quests, updating and checking ToDo List  \n");
			UpdateToDoList(_locallocation);
			CheckToDoList(_locallocation);
		end
	end
	
	
	-- Function to accept a quest
	function AcceptQuest(_questname, _npc, _tag)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGa:: Starting AcceptQuest\n(%s :%s)  \n", _questname, _npc) ; end;
		local _count = 0
		repeat	
			local _queststatus = "none"
			_count = _count + 1
			player:target_Object(_npc);
			AcceptQuestByName(_questname); 
			yrest(1000);
			if _count > 2 then
				printf(" Unable to complete quest:%s at NPC:%s, time to move on. \n", _questname, _npc);
				break
			end
			_queststatus = getQuestStatus(_questname)
			printf(" QuestName: %s, QuestStatus: %s\n", _questname, _queststatus)
		until getQuestStatus(_questname) == "incomplete" or getQuestStatus(_questname) == "complete"	
		if getQuestStatus(_questname) ~= "incomplete" then
			printf(" Done quest: %s, moving on\n", _questname)
			if _tag ~= nil and _tag ~= "" then
				GoToTag(_tag)
			end
		end
		yrest(5000);
	end
	
	
	-- Function to complete a quest
	function CompleteQuest(_questname, _npc, _reward)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting CompleteQuest\n(%s :%s)  \n", _questname, _npc) ; end;
		local _count = 0		
		repeat
		local _reward = _reward or 1
			_count = _count + 1
			player:target_NPC(_npc);
			CompleteQuestByName(_questname, _reward); 
			yrest(1000);
			if _count > 2 then
				printf(" Unable to complete quest:%s at NPC:%s, time to move on. \n", _questname, _npc);
				break
			end
		until getQuestStatus(_questname) == "not accepted"
		yrest(5000);
	end
	
-- Function to check where the bot is up to with its quests
	function CheckQuestList()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGq:: Starting QuestList()  \n") ; end;
		
		questcomplete = "Unknown"
		questincomplete = "Unknown"
		questnotaccepted = "Unknown"
		dothisquest = "none"
		local SILVERSPRING = 2002
		local RAVENFELL = 1003
		local ASLAN_VALLEY =1004
		local YSTRA_HIGHLANDS = 1005
		local DUST_DEVIL_CANYON = 1006
		local WEEPING_COAST = 1007
		
		local questlist = {
		[SILVERSPRING]		= { [1] = {	qlevel = 10, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" },
								[2] = {	qlevel = 10, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" } },
		[RAVENFELL]			= { [1] = {	qlevel = 10, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" },
								[2] = {	qlevel = 10, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" } },
		[ASLAN_VALLEY]		= { [1] = {	qlevel = 20, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" },
								[2] = {	qlevel = 20, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" } },
		[YSTRA_HIGHLANDS]	= { [1] = {	qlevel = 33, questid = 420884, acceptnpc = "Joey Klongen", completenpc = "Laura Febrey", itemreward = 0, questname = "Challenge of the Arctic Training Battalion" },
								[2] = {	qlevel = 33, questid = 420885, acceptnpc = "Laura Febrey", completenpc = "Laura Febrey", itemreward = 0, questname = "Retrieve Rations" },
								[3] = {	qlevel = 33, questid = 420886, acceptnpc = "Laura Febrey", completenpc = "Ross Bete", itemreward = 0, questname = "Report to Instructor of the Second Stage" },
								[4] = {	qlevel = 33, questid = 420887, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "Berhus out of Control" },
								[5] = {	qlevel = 34, questid = 420, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "Report to Instructor of the Third Stage" },
								[6] = {	qlevel = 33, questid = 420, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "Harsh Sea of Snow" },
								[7] = {	qlevel = 33, questid = 420, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "Report to Instructor of the Fourth Stage" },
								[8] = {	qlevel = 33, questid = 420, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "Enough Courage to Survive" },
								[9] = {	qlevel = 33, questid = 420, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "Report to Instructor of the Fifth Stage" },
								[10] ={	qlevel = 33, questid = 420, acceptnpc = "Laura Febrey", completenpc = "NPC", itemreward = 0, questname = "A Black and White World" },
								[11] ={	qlevel = 33, questid = 420, acceptnpc = "Rachel Greng", completenpc = "NPC", itemreward = 0, questname = "Training Complete" } },

		[DUST_DEVIL_CANYON] = { [1] = {	qlevel = 42, questid = 420765, acceptnpc = "Marston", completenpc = "Loran Brey", itemreward = 0, questname = "Fortress on Alert" },
								[2] = {	qlevel = 42, questid = 420766, acceptnpc = "Loran Brey", completenpc = "Loran Brey", itemreward = 0, questname = "Competent Delivery Staff" },
								[3] = {	qlevel = 42, questid = 420767, acceptnpc = "Loran Brey", completenpc = "Frank", itemreward = 0, questname = "The First Quest" },
								[4] = {	qlevel = 42, questid = 420777, acceptnpc = "Frank", completenpc = "Loran Brey", itemreward = 0, questname = "Bring it Back" },
								[5] = {	qlevel = 42, questid = 420768, acceptnpc = "Loran Brey", completenpc = "Andor", itemreward = 0, questname = "Delivering Important Supplies" },
								[6] = {	qlevel = 42, questid = 420769, acceptnpc = "Andor", completenpc = "Andor", itemreward = 1, questname = "A Necessary Evil to Survive" },
								[7] = {	qlevel = 42, questid = 420770, acceptnpc = "Outpost Soldier - Loder", completenpc = "Outpost Soldier - Loder", itemreward = 1, questname = "Surviving the Desert" },
								[8] = {	qlevel = 42, questid = 420771, acceptnpc = "Outpost Soldier - Loder", completenpc = "Outpost Soldier - Loder", itemreward = 0, questname = "The Secret of Venom" },
								[9] = {	qlevel = 42, questid = 420772, acceptnpc = "Andor", completenpc = "Thasroken", itemreward = 0, questname = "Supporting the Front" },
								[10] = {qlevel = 42, questid = 420773, acceptnpc = "Thasroken", completenpc = "Thasroken", itemreward = 2, questname = "Helping on the Front" },
								[11] = {qlevel = 42, questid = 421348, acceptnpc = "Thasroken", completenpc = "Outpost Soldier - Naidi", itemreward = 0, questname = "Toward the Second Defence Line" },
								[12] = {qlevel = 42, questid = 420774, acceptnpc = "Outpost Soldier - Naidi", completenpc = "Outpost Soldier - Naidi", itemreward = 0, questname = "Helping on the Second Front" },
								[13] = {qlevel = 42, questid = 421349, acceptnpc = "Outpost Soldier - Naidi", completenpc = "Loran Yates", itemreward = 0, questname = "Seeing Loran Yates" },
								[14] = {qlevel = 42, questid = 420775, acceptnpc = "Loran Yates", completenpc = "Loran Yates", itemreward = 0, questname = "The Story Behind the City Wall" },
								[15] = {qlevel = 42, questid = 420776, acceptnpc = "Loran Yates", completenpc = "Loran Yates", itemreward = 2, questname = "Fire the Temp" },
								[16] = {qlevel = 42, questid = 421394, acceptnpc = "Lajos Halka", completenpc = "Rodney", itemreward = 0, questname = "The Order of Darl Glory" },
								[17] = {qlevel = 42, questid = 421395, acceptnpc = "Rodney", completenpc = "Lajos Halka", itemreward = 0, questname = "Labor Shortage" },
								[18] = {qlevel = 42, questid = 421396, acceptnpc = "Lajos Halka", completenpc = "Mark", itemreward = 0, questname = "Supporting the Big Dig" },
								[19] = {qlevel = 42, questid = 421392, acceptnpc = "Solins", completenpc = "Solins", itemreward = 0, questname = "Necklace Search" },
								[20] = {qlevel = 43, questid = 420782, acceptnpc = "Borst", completenpc = "Borst", itemreward = 0, questname = "Reason for Delay" },
								[21] = {qlevel = 43, questid = 420360, acceptnpc = "Solins", completenpc = "Peter", itemreward = 0, questname = "Mysterious Treasure Chest" },
								[22] = {qlevel = 43, questid = 421393, acceptnpc = "Solins", completenpc = "Evelyn", itemreward = 0, questname = "Returning the Necklace" },
								[23] = {qlevel = 43, questid = 420357, acceptnpc = "Evelyn", completenpc = "Evelyn", itemreward = 0, questname = "Grandfather's Blessing" },
								[24] = {qlevel = 43, questid = 420361, acceptnpc = "Peter", completenpc = "Solins", itemreward = 0, questname = "Master Key" }},

		[WEEPING_COAST]		= { [1] = { qlevel = 50, questid = 123456, acceptnpc = "Howey Mingstun", completenpc = "Howey Mingstun", itemreward = 0, questname = "The Strange Fish People and the Fishermen" },
								[2] = { qlevel = 50, questid = 123456, acceptnpc = "Howey Mingstun", completenpc = "Howey Mingstun", itemreward = 1, questname = "Damned Pirates" },
								[3] = { qlevel = 50, questid = 422187, acceptnpc = "Howey Mingstun", completenpc = "Mog Feilis", itemreward = 0, questname = "Buried Treasure on the Beach" },
								[4] = { qlevel = 50, questid = 422188, acceptnpc = "Mog Feilis", completenpc = "Mog Feilis", itemreward = 0, questname = "A Legendary Mystery Crab" },
								[5] = { qlevel = 50, questid = 422189, acceptnpc = "Mog Feilis", completenpc = "Mog Feilis", itemreward = 4, questname = "Tasting is Knowing" },										
								[6] = { qlevel = 50, questid = 422190, acceptnpc = "Howey Mingstun", completenpc = "Howey Mingstun", itemreward = 0, questname = "Repairing the Boat" },
								[7] = { qlevel = 50, questid = 422191, acceptnpc = "Mog Feilis", completenpc = "Mog Feilis", itemreward = 0, questname = "Horseshoe Crab Recipe" },
								[8] = { qlevel = 50, questid = 422192, acceptnpc = "Howey Mingstun", completenpc = "Howey Mingstun", itemreward = 0, questname = "Fishermen's Tale" },
								[9] = { qlevel = 50, questid = 422193, acceptnpc = "Howey Mingstun", completenpc = "Ment Milon", itemreward = 3, questname = "Bait Seller Boy" },
								[10] = {qlevel = 50, questid = 422194, acceptnpc = "Ment Milon", completenpc = "Ment Milon", itemreward = 0, questname = "Family" },
								[11] = {qlevel = 50, questid = 422195, acceptnpc = "Ment Milon", completenpc = "Howey Mingstun", itemreward = 0, questname = "Kami Mushroom Whiskey" },
								[12] = {qlevel = 50, questid = 422196, acceptnpc = "Howey Mingstun", completenpc = "Howey Mingstun", itemreward = 3, questname = "In Wine There is Truth" },
								[13] = {qlevel = 50, questid = 420919, acceptnpc = "Loluka Nilo", completenpc = "Loluka Nilo", itemreward = 0, questname = "Uninvited Guests" },
								[14] = {qlevel = 50, questid = 420908, acceptnpc = "Kafas Degan", completenpc = "Kafas Degan", itemreward = 1, questname = "Station" },
								[15] = {qlevel = 50, questid = 420909, acceptnpc = "Kafas Degan", completenpc = "Kafas Degan", itemreward = 1, questname = "Pirate Work" } },									
		[6]					= { [1] = {	qlevel = 55, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" },
								[2] = {	qlevel = 55, questid = 123456, acceptnpc = "NPC", completenpc = "NPC", itemreward = 0, questname = "Name" } },
						};
		local _zoneID = RoMScript("GetZoneID()")
		local _zonename = RoMScript("GetZoneLocalName(".._zoneID..")");
		local zonequestlist = questlist[_zoneID];
		printf(" Player: _zoneID:%d _zonename:\n", _zoneID)
		local _queststatus = "Unknown"		
		
		for i,v in ipairs(zonequestlist)  do
			player:update()	
			-- local _startNPC = v.acceptnpc
			-- local _finishNPC = v.completenpc
			-- local _itemreward = v.itemreward
			local _questID = v.questid
			local _questlevel = v.qlevel
			local _questname = v.questname
			local _questcheck = RoMScript("CheckQuest(".._questID..")")			
			
			if _questcheck == 0 and questnotaccepted == "Unknown" then
				_queststatus = "Not Accepted"
				questnotaccepted = _questname
			elseif _questcheck == 1 then
				if getQuestStatus(_questname) == "complete" and _queststatus == "Unknown" then
					_queststatus = "Accepted Completed"
					questcomplete = _questname
				elseif getQuestStatus(_questname) == "incomplete" and _queststatus == "Unknown" then
					_queststatus = "Accepted Incomplete"
					questincomplete = _questname
				end
			elseif _questcheck == 2 and _queststatus == "Unknown" then
				_queststatus = "Handed In"
			end				
			printf(" ID:%d Level:%d Status:%s Name:%s\n", _questID, _questlevel, _queststatus, _questname)
		end
		
		if _queststatus ~= "Handed In" then			
			if questincomplete ~= "Unknown" then
				dothisquest = questincomplete
			elseif questcomplete ~= "Unknown" then
				dothisquest = questcomplete
			end
			printf(" Have a quest to do: %s\n", dothisquest)
			if _showfunctiondebug then printf(" questnotaccepted: %s, questincomplete: %s, questcomplete: %s \n", questnotaccepted, questincomplete, questcomplete) ; end;
		else
			printf(" Have no quests to do in this zone, all Handed In")
		end
		return dothisquest
	end
	
	function GetQuestStatus(_questID, _questname) 
		if _showfunctiondebug then cprintf(cli.blue," DEBUGg:: Starting GetQuestStatus()  \n") ; end;
	-- CheckQuest(questID) should return 0 1 2 
	-- 0 for not started quest, 
	-- 1 is that you have quest in log
	-- 2 for completed (not in quest log anymore) confirmede
	
	-- local _questcheck = RoMScript("CheckQuest("..questID..")") 
	-- if questcheck == 1 then 
	-- if getQuestStatus() ~= "complete" then
	--do what is needed to completed quest
	-- else
	--go hand it in
	-- end
	-- elseif questcheck == 2 then
	--ignore quest as it has been completed
	-- else -- must be 0 and not in log or fully completed yet
	--get quest and go and complete it
	-- end
	end	
	
	-- Function to talk to NPC using a selected option
	function TalkToNPC(_npc, _option)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting TalkToNPC(%s)\n", _npc) ; end
		player:target_NPC(_npc);
		sendMacro("ChoiceOption(" .. _option .. ");");
		yrest(5000)
	end
	
	
	
	-- Function to adjust the profile combat distance, for tight spots in a waypoint file
	function CombatDistance(_distance, _loot) -- _distance in digits;  _loot in digits;
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting CombatDistance()  \n") ; end
		
		if not _distance then
			_combatdistance = customsettings.profiledefaults.COMBAT_DISTANCE;
			_lootdistance = customsettings.profiledefaults.LOOT_DISTANCE
			if _showdebug then printf(" DEBUGc:: Setting _combatdistance to %d  and _lootdistance to %d\n", _combatdistance, _lootdistance);end;
		end
		
		local _distance = _distance or _combatdistance;
		local _loot = _loot or _distance;
		if _showdebug then printf(" DEBUGc:: _distance:%d _loot:%d  \n",_distance, _loot)end;
		
		printf(" Setting COMBAT_DISTANCE to %d and LOOT_DISTANCE to %d  for both melee and ranged\n",_distance, _loot)
		changeProfileOption("COMBAT_DISTANCE", _distance);
		changeProfileOption("LOOT_DISTANCE", _loot);
	end		

	
	-- Function to adjust the profile target distance, for tight spots in a waypoint file
	function TargetDistance(_distance) -- _distance in digits;
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting TargetDistance()  \n") ; end
		
		if not _distance then
			_targetdistance = customsettings.profiledefaults.MAX_TARGET_DIST;
			if _showdebug then printf(" DEBUGt:: Setting _targetdistance to %d \n", _targetdistance);end;
		end
		
		local _distance = _distance or _targetdistance;
		if _showdebug then printf(" DEBUGc:: _distance:%d  \n",_distance)end;
		
		printf(" Setting MAX_TARGET_DIST to %d\n",_distance)
		changeProfileOption("MAX_TARGET_DIST", _distance);
	end	
	
	
	-- Function to level the toons skills right up to 70. This is mainly based on the 1-10 in the default bot functions, but extended to level 70.
	function LevelUpSkills1To70(_loadonly)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGl:: Starting LevelUpSkills1To70()  \n") ; end
		
		player:update();
		
		-- level up the skill by using an internal leveling table
		-- load the skills for using into the profile skill table
		-- CAUTION: addressing a invalid skill will crash the RoM client
		local skillLevelupMap = {
			[CLASS_WARRIOR]	= {  [1] = { aslevel = 1, skillname = "WARRIOR_SLASH", skilltab = 2, skillnum = 1, atlevel = {99} },
								 [2] = { aslevel = 2, skillname = "WARRIOR_OPEN_FLANK", skilltab = 4, skillnum = 2, atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,42,44,46,48,50 } },
								 [3] = { aslevel = 2, skillname = "WARRIOR_PROBING_ATTACK", skilltab = 4, skillnum = 3, atlevel = {99} },
								 [4] = { aslevel = 6, skillname = "WARRIOR_THUNDER", skilltab = 4, skillnum = 5, atlevel = {0} } },
			[CLASS_SCOUT]	= {  [1] = { aslevel = 1, skillname = "SCOUT_SHOT", atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,42,44,46,48,50} },
								 [2] = { aslevel = 2, skillname = "SCOUT_WIND_ARROWS", atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,42,44,46,48,50} },
								 [3] = { aslevel = 4, skillname = "SCOUT_VAMPIRE_ARROWS", atlevel = {99} },
								 [4] = { aslevel = 6, skillname = "SCOUT_RANGED_WEAPON_MASTERY", skilltab = 4, skillnum = 4, atlevel = {99} },
								 [5] = { aslevel = 8, skillname = "SCOUT_JOINT_BLOW", atlevel = {99} },
								 [6] = { aslevel = 16, skillname = "SCOUT_THROAT_ATTACK", atlevel = {99} } },
			[CLASS_ROGUE]	= {  [1] = { aslevel = 1, skillname = "ROGUE_SHADOWSTAB", atlevel = {0} },
								 [2] = { aslevel = 2, skillname = "ROGUE_LOW_BLOW", atlevel = {0} },
								 [3] = { aslevel = 6, skillname = "ROGUE_WOUND_ATTACK", atlevel = {0} },
								 [4] = { aslevel = 8, skillname = "ROGUE_BLIND_STAB", atlevel = {0} } },
			[CLASS_MAGE]	= {  [1] = { aslevel = 1, skillname = "MAGE_FLAME", 										atlevel = {99} }, 
								 [2] = { aslevel = 2, skillname = "MAGE_ELECTROSTATIC_CHARGE", 							atlevel = {} },
								 [3] = { aslevel = 4, skillname = "MAGE_FIREBALL", 										atlevel = {99} },
								 [4] = { aslevel = 8, skillname = "MAGE_LIGHTNING", 									atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,14,15,16,18,20,21,22,24,26,28,30,31,32,34,36,38,40,41,42,44,46,48,50} },
								 [5] = { aslevel = 10, skillname = "MAGE_DISCHARGE", skilltab = 4, 		skillnum = 6, 	atlevel = {} } ,
								 [6] = { aslevel = 10, skillname = "MAGE_ELECTRIC_BOLT", skilltab = 4, 	skillnum = 7, 	atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,29,30,31,32,33,35,37,39,40,41,42,43,45,47,49,50} },
								 [7] = { aslevel = 12, skillname = "MAGE_WISDOM", 		skilltab = 2, 	skillnum = 3, 	atlevel = {99} },
								 [8] = { aslevel = 14, skillname = "MAGE_METEOR_SHOWER",	skilltab = 4,skillnum = 8,	atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,40,41,42,44,46,48,50} },
								 [9] = { aslevel = 16, skillname = "MAGE_INTENSIFICATION", skilltab = 2,skillnum = 4, 	atlevel = {} },
								 [10] = { aslevel = 22, skillname = "MAGE_FIRE_KNOWLEDGE", skilltab = 4,skillnum = 13, 	atlevel = {99} },
								 [11] = { aslevel = 28, skillname = "MAGE_ENERGY_INFLUX", skilltab = 4,skillnum = 16, 	atlevel = {1,2,3,4,5,6,7,8,9,10,11,12,14,15,16,18,20} } },
			[CLASS_PRIEST]	= {  [1] = { aslevel = 1, skillname = "PRIEST_RISING_TIDE", atlevel = {0} },
								 [2] = { aslevel = 1, skillname = "PRIEST_URGENT_HEAL", atlevel = {0} },
	--							 [3] = { aslevel = 2, skillname = "PRIEST_WAVE_ARMOR", atlevel = {0} },	-- needs too much mana
								 [3] = { aslevel = 4, skillname = "PRIEST_REGENERATE", atlevel = {0} } ,
								 [4] = { aslevel = 8, skillname = "PRIEST_HOLY_AURA", atlevel = {0} } },
			[CLASS_KNIGHT]	= {  [1] = { aslevel = 1, skillname = "KNIGHT_PUNISHMENT", atlevel = {99} },
								 [2] = { aslevel = 1, skillname = "KNIGHT_HOLY_STRIKE", atlevel = {99} },
								 [3] = { aslevel = 4, skillname = "KNIGHT_DISARMAMENT", atlevel = {99} },
								 [4] = { aslevel = 8, skillname = "KNIGHT_SHIELD_OF_ATONEMENT", atlevel = {99} },
								 [5] = { aslevel = 12, skillname = "KNIGHT_ENHANCED_ARMOR", atlevel = {99} } },
			[CLASS_WARDEN]	= {  [1] = { aslevel = 1, skillname = "WARDEN_CHARGED_CHOP", atlevel = {0} },
								 [2] = { aslevel = 1, skillname = "WARDEN_ENERGY_ABSORB", atlevel = {0} },
								 [3] = { aslevel = 2, skillname = "WARDEN_THORNY_VINE", atlevel = {0} },
								 [4] = { aslevel = 4, skillname = "WARDEN_BRIAR_SHIELD", atlevel = {0} },
								 [5] = { aslevel = 8, skillname = "WARDEN_POWER_OF_THE_WOOD_SPIRIT", atlevel = {0} } },
			[CLASS_DRUID]	= {  [1] = { aslevel = 1, skillname = "DRUID_RECOVER", atlevel = {0} },
								 [2] = { aslevel = 1, skillname = "DRUID_EARTH_ARROW", atlevel = {0} },
								 [3] = { aslevel = 2, skillname = "DRUID_BRIAR_ENTWINEMENT", atlevel = {0} },
								 [4] = { aslevel = 6, skillname = "DRUID_RESTORE_LIFE", atlevel = {0} } },
			};
			
		player:update()
		local leveluptable = skillLevelupMap[player.Class1];
		printf(" Player: Level:%d Class:%s\n", player.Level, player.Class1)
		
		for i,v in pairs(leveluptable)  do
			if (_loadonly ~= "loadonly") and ( player.Level >= v.aslevel ) then
				player:update()
				local _skillname = v.skillname
				
				if database.skills[_skillname] == nil then
					printf(" Skill:%s is not in the Skill database, going to add it in.\n", _skillname)
					local tmp = CSkill();
					tmp.skilltab = v.skilltab
					tmp.skillnum = v.skillnum
					database.skills[_skillname] = tmp
				end
				local skill_from_db = database.skills[_skillname];
				
				if skill_from_db.skilltab == nil or skill_from_db.skillnum == nil or
					skill_from_db.skilltab == 0 or skill_from_db.skillnum == 0 then
					skill_from_db.skilltab = v.skilltab
					skill_from_db.skillnum = v.skillnum
					printf(" added details to skillnum:%d and skilltab:%d for skill:%s\n",skill_from_db.skillnum, skill_from_db.skilltab, _skillname)
				end
				
				if _showdebug then printf(" DEBUGl:: AsLevel:%d Skill Name:%s  \n", v.aslevel, _skillname) ; end;
				local name, _, icon, _, rank, type, upgradeCost, isSkillable, isAvailable = RoMScript("GetSkillDetail("..skill_from_db.skilltab..","..skill_from_db.skillnum..")")
				printf(" skillnum:%d skilltab:%d rank:%d skill:%s\n",skill_from_db.skillnum, skill_from_db.skilltab, rank, _skillname)
				local whentolevel = v.atlevel
				
				for j,w in ipairs(whentolevel) do
					if w == 99 then							
						local _timestolevel = player.Level - rank
						if _showdebug then printf(" DEBUGl:: w == 99, max out skill:%s atempt to add %d levels\n",_skillname, _timestolevel) ; end;
						if _timestolevel > 0 then
							printf(" Adding (or attempting to add) levels to skill:%s x%d\n",_skillname, _timestolevel) ;
							levelupSkill(v.skillname, _timestolevel);
						end
					elseif player.Level >= w then
						if j > rank then
							printf("J = %d \n", j)
							_timestolevel = j - rank
							printf(" Adding (or attempting to add) %d level(s) to skill:%s \n", _timestolevel, _skillname)
							levelupSkill(v.skillname, _timestolevel);
						else
							printf(" Skill:%s is already at the desired rank:%d for the class level:%d \n", _skillname, rank, player.Level)
						end
					end
				end
			end
		end
	end


	-- Function to open giftbag up to level 70. I am adding to the giftbag1to70.xml as my bot get to that level. 
	-- Only just added this function, so still adding items. 
	function OpenGiftbags1To70(_player_level)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGo:: Starting OpenGiftbags1To70()  \n") ; end

		root = xml.open(getExecutionPath() .. "/database/giftbags1to70.xml");
		elements = root:getElements();

		for i,v in pairs(elements) do
			local itemid, type, armor, level, name;
			local tmp = {};

			itemid = v:getAttribute("itemid");
			type   = v:getAttribute("type");
			armor  = v:getAttribute("armor");
			level  = v:getAttribute("level");
			name   = v:getAttribute("name");

			if (itemid) then tmp.itemid = itemid; end;
			if (type)   then tmp.type   = type;   end;
			if (armor)  then tmp.armor  = armor;  end;
			if (level)  then tmp.level  = level;  end;
			if (name)   then tmp.name   = name;   end;

			database.giftbags[i] = tmp;
		end
		if( not _player_level) then _player_level = player.Level; end
		cprintf(cli.lightblue, language[170], _player_level );	-- Open and equipt giftbag for level

		-- open giftbag and equipt content
		--	yrest(2000);	-- time for cooldowns to phase-out
		for i,v in pairs(database.giftbags)  do
			if( v.level == _player_level) then
				if( v.armor == armorMap[player.Class1]  or		-- only if items have the right armor
					v.armor == nil ) then						-- or is armor independent
					local hf_return, hf_itemid, hf_name = inventory:useItem( v.itemid );	-- open bag or equipt item

					if ( hf_return ) then
						cprintf(cli.lightblue, language[171], hf_name );	-- Open/eqipt item:
					else
						cprintf(cli.yellow, language[174], v.name );		-- item not found
					end
					yrest(2000);					-- wait for using that item

					if( v.type == "bag" ) then		-- after opening bag update inventory
						yrest(4000);				-- some more time to open the bag
						inventory:update();			-- update slots
					end;
				end;
			end;
		end
	end

	-- Function to read any monster cards in your bag.
	function LearnMonsterCards()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGl:: Starting LearnMonsterCards()  \n") ; end;
		local _startslot = 60;
		local _finishslot = 120;
		PrintLine();
		printf(" Checking for Monster Cards in Inventory\n");
		for item = _startslot, _finishslot, 1 do -- for each inventory
		local slotitem = inventory.BagSlot[item];
		local slotNumber = slotitem.SlotNumber - 60
			if  (slotitem.Available and not slotitem.Empty) then
				local _itemname = slotitem.Name;
				local _itemtype = slotitem.ObjType;
				local _itemid = slotitem.id;
				if _itemtype == 6 then
					slotitem:use()
					yrest(10000)
					printf(" Learning %s in slot%02d: \n", _itemname, slotNumber );
				end
			end
		end
		_learnmonstercards = 0;
		return false
	end
	
	-- Function to bank any items that you want to keep, but not cart around in your main bags.
	-- mainly items from giftbags end up here, or Phirius Token Coins
	function BankItem(_banker, _option, _item)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGb:: Starting BankItem()  \n") ; end;
		local _startslot = 60;
		local _finishslot = 120;		
		local ItemsToBankTable = {	[1] = { itemid = 201201, itemname = "Moon Jewel - Basic"},
									[2] = { itemid = 200840, itemname = "Star Jewel - Basic"},
									[3] = { itemid = 202902, itemname = "Marking Ink"},
									[4] = { itemid = 202903, itemname = "Transport Rune"},
									[5] = { itemid = 202152, itemname = "Fruit of Extra Experience"},
									[6] = { itemid = 202435, itemname = "Home-sweet-home"},
									[7] = { itemid = 201521, itemname = "Rune Gift Bag I"},
									[8] = { itemid = 201522, itemname = "Rune Gift Bag II"},
									[9] = { itemid = 201523, itemname = "Rune Gift Bag III"},
									[10] = { itemid = 201524, itemname = "Rune Gift Bag IV"},
									[11] = { itemid = 201525, itemname = "Rune Gift Bag V"},
									[12] = { itemid = 202506, itemname = "Golden Repair Hammer"},
									[13] = { itemid = 203574, itemname = "High Quality Experience Potion"},
									[14] = { itemid = 221394, itemname = "Fountain of Talent"},
									[15] = { itemid = 203038, itemname = "Phirius Token Coin"},
									[16] = { itemid = 204222, itemname = "Strange Crystal"},
									[17] = { itemid = 201086, itemname = "Advanced Skill Reset Stone"},
									[18] = { itemid = 203577, itemname = "Arcane Transmutor Charges - 10 Charges"},
									[19] = { itemid = 201141, itemname = "Phoenixs Redemption"},
									[20] = { itemid = 202434, itemname = "Daily Quest Ticket"},
									[21] = { itemid = 201088, itemname = "Advanced Weapon Driller"},
									[22] = { itemid = 202881, itemname = "Purified Fusion Stone"},
									[23] = { itemid = 201238, itemname = "Advanced Armor Driller"},
								 };	
		if _banker == "checkonly" or _banker == nil then
			for i,v in pairs(ItemsToBankTable)  do		
				local toslot = inventory:findItem(v.itemid)
				if toslot then
					printf(" Item %s needs Banking, adding Banking to the ToDo list.\n", v.itemname);
					_bankitem = 1;
					if settings.profile.options.BANK_ITEMS == false then
						_bankitem = 0;
					end
					break;
				else
					_bankitem = 0;
				end
			end
		else
			player:target_NPC(_banker);
			sendMacro("ChoiceOption(" .. _option .. ");");
			yrest(2000); -- opening the bank box								 
			inventory:update();
			if _item == nil then 
				for i,v in pairs(ItemsToBankTable)  do		
					local toslot = inventory:findItem(v.itemid)
					if toslot then
						inventory:useItem(v.itemid)
						printf(" Banked item %s.\n", v.itemname);
					end
				end
			else
				inventory:useItem(_item)
				printf(" Banked item %s.\n", _item);
			end
		end
	end
	
	-- Function just for gathering quest info, for adding into the quest tables above
	function testgetquestinfo()
		if _showfunctiondebug then cprintf(cli.blue," DEBUGt:: Starting testgetquestinfo()  \n") ; end;
		local index, catalogID, name, track, level, daily, bDaily_num, iQuestType, questID, completed, QuestGroup = RoMScript("GetQuestInfo(1)")
		if index ~= nil then
			printf(" index:%s\n catalogID:%s\n name:%s\n track:%s\n level:%s\n daily:%s\n bDaily_num:%s\n iQuestType:%s\n questID:%s\n completed:%s\n QuestGroup:%s\n",index, catalogID, name, track, level, daily, bDaily_num, iQuestType, questID, completed, QuestGroup)
			local _questcheck = RoMScript("CheckQuest("..questID..")")
			printf(" _questcheck:%s\n",_questcheck)
		else
			local _questcheck = RoMScript("CheckQuest(420776)")
			printf(" _questcheck 420776:%s\n",_questcheck)
		end
		
	end
	
	
	--=== Created by Lisa 	===--
	--=== 		V 1.1 		===--
	function ChangeOptionFriendMob(_type,_name,_addremove)
		if _showfunctiondebug then cprintf(cli.blue," DEBUGc:: Starting ChangeOptionFriendMob(_type,_name,_addremove)  \n", _type,_name,_addremove) ; end;
		--examples	ChangeOptionFriendMob("mob", "Wolf", "Add")
		--examples	ChangeOptionFriendMob("friend", "Hokeypokey", "Remove")

		if _name == nil or _name == "" then
			printf("Need to specify name.\n")
		end

		if _addremove == nil then _addremove = "add" end
		
		addremove = string.lower(_addremove)
		
		if addremove ~= "add" and addremove ~= "remove" then
			printf("Wrong usage of arg#2, _addremove")
		end

		if( _name ) then name = trim(_name) end;
		if _type == "friend" then 
			if addremove == "add" then 
				for k,v in ipairs(settings.profile.friends) do
					if v == name then return end
				end
				table.insert(settings.profile.friends, name);
				for k,v in ipairs(settings.profile.friends) do
					printf(k.." "..v.."\n")
				end
			end

			if addremove == "remove" then 
				for k,v in ipairs(settings.profile.friends) do
					if v == name then
					table.remove(settings.profile.friends,k);
					printf("Removing friend "..v.."\n")
					end
					printf(k.." "..v.."\n")
				end
			end
		end
		if _type == "mob" then 
			if addremove == "add" then 
				for k,v in ipairs(settings.profile.mobs) do
					if v == name then return end
				end
				table.insert(settings.profile.mobs, name);
				for k,v in ipairs(settings.profile.mobs) do
					printf(k.." "..v.."\n")
				end
			end

			if addremove == "remove" then 
				for k,v in ipairs(settings.profile.mobs) do
					if v == name then
						table.remove(settings.profile.mobs,k);
						printf("Removing friend "..v.."\n")
					end
					printf(k.." "..v.."\n")
				end
			end
		end

	end
	
	-- things to add
	-- 1. (done)add check for arrows in bag and sell them. Happens when swapping class and it removes arrows from ammo slot, leving some arrows in bags.
	-- 2. (ongoing) add a Function to increase skill levels when toon gains a level
	-- 3. (done) mail blue items to clear more bag space
	-- 4. (done)sell potions and ammo that is now a lower level than the best toon can use 
	-- 5. (done) mail runes that get to stack of 99
	-- 6. (done)read monster cards that have been looted
	-- 7. (done) put bound items into the bank
	-- 8. equip better items
	-- 9. (ongoing)use gift bag beyond level 10
	-- 10.(added custom options)scout at low level has no mana, and equipment check saying it is low. dont need mana as low scout
	-- 11.(added custom options)scout at low levels is forcing Run due to low quivers.
	-- 12. mount horse from logar to Varanas, and when heading to/from

	
	
	
